/*
    GetDriveType
    A routine posted by Romain Strieff on the VdBASE Newsgroups
    and modified by Ken Mayer to be a tad more friendly ...

    This routine will return the type of drive for a specific
    drive letter. It may require looping through all possible
    drive letters if you are looking for one in particular ...

    Syntax: GetDrivetype( cRootPath )
            where: cRootPath is the path to the root of the
                   drive, i.e,, "A:\"

    Usage:  set procedure to getdrive additive
            ? getDriveType( "C:\" )   
*/

function GetDriveType( cRootPath )

   if type("GetTypeOfDrive" ) # "FP"
      extern cint GetTypeOfDrive ( CSTRING ) kernel32 ;
                  from "GetDriveTypeA"
   endif

   nType = GetTypeOfDrive( cRootPath )
   do case
      case nType = 0  // Drive type cannot be determined
           cType = "Unknown"
      case nType = 1  // Root directory does not exist
           cType = "Root Directory does not exist!"
      case nType = 2  // DRIVE_REMOVEABLE -- disk can be removed
                      //                     from the drive
           cType = "Removeable Disk"
      case nType = 3  // DRIVE_FIXED -- the disk cannot be removed
           cType = "Fixed Disk"
      case nType = 4  // DRIVE_REMOTE -- remote (network) drive
           cType = "Remote Disk Drive"
      case nType = 5  // DRIVE_CDROM -- what it says
           cType = "CD-ROM"
      case nType = 6  // RAM_DISK -- what it says
           ctype = "RAM Disk"
   endcase
      
return cType

