/*
   SOUNDAPI.CC
   Programmer: Anonymous
   March 12, 1999

   Notes: Found on a floppy sitting around in my "stuff",
   I updated to call "USER32" ... (written for 16-bit)
   Cleaned up the "PlaySound" function a bit ...

   Modified to become a class 3/12/99.

   Usage:
      set procedure to :dUFLP:soundapi.cc additive
      MySound = new soundAPI()

      MySound.QuestionBell() // or one of the other methods noted
                             // below

   Includes the following methods:

   QuestionBell()   -- uses whatever sound is attached to
                       events that bring up the Questionmark
                       dialog
   AttentionBell()  -- same as above, but "Attention" dialog
   ErrorBell()      -- ditto, but "Error" dialog
   FatalBell()      -- ditto, but "Fatal Error" dialog
   CriticalBell()   -- ditto, but "Critical Error" dialog
   PlaySound()      -- pass a wave file and this should
                       play it ...
                       Parameter: cWav is wave file ... include
                                  path if needed
*/

class SoundAPI

#ifndef _SOUNDSTUFF_
   #define _SOUNDSTUFF_
   #define MB_ICONASTERISK             0x00000040
   #define MB_ICONEXCLAMATION          0x00000030
   #define MB_ICONHAND                 0x00000010
   #define MB_ICONQUESTION             0x00000020
   #define MB_OK                       0x00000000
   if type("MessageBeep") # "FP"
      extern CLOGICAL MessageBeep(CINT) USER32
   endif
#endif

   Procedure QuestionBell 
      ? MessageBeep(MB_ICONQUESTION)
   Return

   Procedure AttentionBell 
      ? MessageBeep(MB_OK)
   Return

   Procedure ErrorBell 
      ? MessageBeep(MB_ICONASTERISK)
   Return

   Procedure FatalBell 
      ? MessageBeep(MB_ICONEXCLAMATION)
   Return

   Procedure CriticalBell
      ? MessageBeep(MB_ICONHAND)
   Return

   Procedure PlaySound
      parameter cWav
      // Simple routine to play a wave file
      Private cSound

      cSound = cWAV                    // Verify parameter
      if pCount() == 0 or type( "cSound" ) # "C" 
         return
      endif                  
      cSound = cWAV                    // Verify .WAV file extension
      if right( upper( cSound ),4 ) # ".WAV"
         cSound += ".wav"
      endif
      if file( cWAV )                 // Verify WAV file's existance
         cSound = "play sound filename '" + ;
                  cSound +"'"         // Create the command line
         &cSound                      // Execute the command
      else
         // error message added by KM
         msgbox( "File: "+cWav+ " does not exist.", "Can't play sound", 16 )
      endif

      // some other code removed as it didn't make
      // sense ...
   Return

endclass
// SoundAPI

/*
    End of file: SOUNDAPI.CC
*/
