/****************************************************************************
*
*   Programmers....: Marc Van den Berghen
*
*   Version........: 0.1 (around 2004)
*							1.0 (around 2006)
*							2.0 (17.12.2020)  transforming it into a cc
*							2.1 (18.12.2020)  add register() to avoid UAC
*							2.2 (27.12.2020)  add admin registration
*							2.3 (26.01.2021)  in from, to, cc and bcc the backslash \
*													can be used to add a display name		
*							
*   Dependencies...: SMTP_Mail_Sender.dll  (8KB)
*							mail_item.tlb			 (5KB)	
*
*   Usage..........: email = new mv_mail()
*							if email.errorcode <> 0 ; do errorhandling ; endif
*							email.SetHost(),SetPort(),SetUser(),SetPW(),SetSSL()
*							// with these you set the SMTP Parameter
*
*							email.SetFrom(),SetSubject(),SetBody(),SetPriority()
*							SetHtmlBody()
*							// with these you set the individual mail properties
*				
*							email.SetAddress(),SetCC(),SetBCC(),SetAttachmenT()
*							email.SetAddress("dbase@dbase.net\dbase LLC")	
*							// these methods await either a single string
*							// or an array of string values. These must be 
*							// valid email addresses or filenames 
*	
*							email.Send() 
*							email.clear()  resets the individual mail properties
*							email.clear(true) also resets the SMTP properties
*
*							email.errorcode and email.errortext hold error info
*
*							to release the email object, it i enough to null it
*							email = Null
*
*	 Special........: email.register(dllpath,badmin) will try to register
*							the oleautoclient on your system.
*							dllpath is the path to dll and tlb. If it is not 
*							specified, the class will look program's directory
*							If the .dll or the .tlb are not found, the registration
*							will fail
*							Note: to avoid UAC, the dll is registered for the 
*							current user (default). If the programm is run on the same
*							machine by different users, each has to register once.
*							There is a second parameter, that if set to true, will
*							register the mailitem in the HKEY_CLASSES_ROOT  branch
*							of the registry, that is for ALL users.
*							The registration with admin = true will only succed
*							when dbase is started with elevated priviliges.
*
**************************************************************************/


Class mv_mail

	*protect mobj,metaset,b_ok,oleex,metacall,olecheck

	this.errorcode		= 0	 		// success
	this.errortext		= "No Error"
	
	*** SMTP - Parameters
	
	this.host			= ""	// placeholder. Fill it with the SetHost method
	this.port			= 25	// Default. SetPort(nport)
	this.user			= ""	// placeholder. Fill it with SetUser(cuser)
	this.password		= ""  // placeholder. Fill it with SetPW(cpw)
	this.ssl				= false // default. SetSSL(bssl)

	*** Individual Mail Parameters

	this.from 		 	= ""  // you must add a valid address: SetFrom(cfrom)
	this.replyto		= ""	// in case you need it: SetReplyto(crply)
	this.priority	   = 1	// 0= Low, 1 = normal , 2 = High 
	this.subject		= ""	// SetSubject(csubject)
	this.Body			= ""  // SetBody(cbody)	
	this.htmlbody		= false // default. SetHtmlBody(bhtml)
	
	this.b_ok			= true // for internal test if mailitem could be instanced
	this.oleex			= new OLEEXCEPTION() //internal errorchecking
	
	try
		this.mobj = new oleautoclient("vdb_mail.mail_item")
	catch(exception e)
		this.errorcode = e.code
		this.errortext = e.message 
		this.b_ok		= false
	endtry
	
	// metaset(value to set, default on error, member to set, olemember to set)
	
	function SetHost(cHost)	; return iif(this.b_ok,this.metaset(chost,"",this.host,this.mobj.host),false)
	function SetPort(nport) ; return iif(this.b_ok,this.metaset(int(nport),25,this.port,this.mobj.port),false)
	function SetUser(cuser) ; return iif(this.b_ok,this.metaset(cuser,"",this.user,this.mobj.user),false)
	function SetPW(cpw)     ; return iif(this.b_ok,this.metaset(cpw,"",this.password,this.mobj.password),false)
	function SetSSL(bssl)   ; return iif(this.b_ok,this.metaset(bssl,false,this.ssl,this.mobj.ssl),false)
	function SetFrom(cfrom) ; return iif(this.b_ok,this.metaset(cfrom,"",this.from,this.mobj.from),false)
	function SetReplyto(crply); return iif(this.b_ok,this.metaset(crply,"",this.replyto,this.mobj.replyto),false)
	function SetPriority(np); return iif(this.b_ok,this.metaset(np,1,this.priority,this.mobj.priority),false)
	function SetSubject(csubject); return iif(this.b_ok,this.metaset(csubject,"",this.subject,this.mobj.subject),false)
	function SetBody(cbody)	; return iif(this.b_ok,this.metaset(cbody,"",this.body,this.mobj.body),false)
	function SetHtmlBody(bhtml); return iif(this.b_ok,this.metaset(bhtml,false,this.htmlbody,this.mobj.htmlbody),false)
	
	//metacall(value to set, method-pointer, array_allowed)
	
	function SetAddress(c_a_adr) ; return iif(this.b_ok,this.metacall(c_a_adr,1,true),false)
	function SetCC(c_a_cc) ; return iif(this.b_ok,this.metacall(c_a_cc,2,true),false)
	function SetBCC(c_a_bcc) ; return iif(this.b_ok,this.metacall(c_a_bcc,3,true),false)
	function SetReadreceipt(c_adr) ; return iif(this.b_ok,this.metacall(c_adr,4,false),false)
	function SetReceivereceipt(c_adr) ; return iif(this.b_ok,this.metacall(c_adr,5,false),false)
	function SetAttachment(c_a_att); return iif(this.b_ok,this.metacall(c_a_att,6,true),false)
	
	function metaset(pvalue,pdefault,rpthis,rpmobj)
	
		// all the setter methods share the same function body,
		// so we use this metafunction to set the different members 
		
		// clear the error-members in case of leftovers
		this.errorcode = 0
		this.errortext = "No Error"

		try
			rpmobj = pvalue  // account for all sorts of possible errors 
		catch(exception e)
			this.errorcode = e.code
			this.errortext = e.message
			rpthis    		= pdefault	
			return false
		endtry
		
		rpthis = pvalue 	// assignment went well	
	return true
	
	function metacall
	
		parameters pvalue,fp,array_allowed
		local tmp,ahlp,i,erc
		
		// we use this metafunction to call the different methods
		
		// clear the error-members in case of leftovers
		this.errorcode = 0
		this.errortext = "No Error"
		
		// check the type of the parameters. Some methods accept either
		// a string or an array of strings
		
		tmp = type("pvalue")
		if (not tmp $ "AC") or (tmp="A" and not array_allowed)
			this.errorcode = 1
			this.errortext = "Wrong parameter type"
			return false
		endif
		
		if tmp = "C"     				// if a string is passed, add it to the 
			ahlp = new array()		// empty helper array so we can treat
			ahlp.add(pvalue)			// both cases the same.
		else
			ahlp = pvalue
		endif
		
		try
			for i= 1 to ahlp.size			 // loop through the array	
				do case
					case fp = 1 ; erc = this.mobj.add_to(ahlp[i]) 
					case fp = 2 ; erc = this.mobj.add_cc(ahlp[i])
					case fp = 3 ; erc = this.mobj.add_bcc(ahlp[i])
					case fp = 4 ; erc = this.mobj.set_readreceipt(ahlp[i])
					case fp = 5 ; erc = this.mobj.set_receivereceipt(ahlp[i])
					case fp = 6 ; erc = this.mobj.attach(ahlp[i])
					otherwise   ; erc = false 
				endcase
				if not erc   // returns false on error
					this.errorcode = 2
					this.errortext = this.mobj.error_message
					return false
				endif
			endfor
		catch(exception e)
			this.errorcode = e.code
			this.errortext = e.message
			return false
		endtry
	return true
	
	function Send()
		// clear the error-members in case of leftovers
		this.errorcode = 0
		this.errortext = "No Error"
		if not this.b_ok
			this.errorcode = 4
			this.errortext = "The mail item could not be created"
			return false
		endif
		if not this.mobj.send()   // returns false on error
			this.errorcode = 3
			this.errortext = this.mobj.error_message
			return false
		endif
	return true
	
	Function clear(b_compl)  // reset the mail objects individual properties
		this.mobj.clear()		 // if b_compl = true reset also the SMTP props
		if empty(b_compl) 
			this.sethost(this.host)
			this.setport(this.port)
			this.setuser(this.user)
			this.setpw(this.password)
			this.setssl(this.ssl)
		else
			this.host			= ""	
			this.port			= 25	
			this.user			= ""	
			this.password		= ""  
			this.ssl				= false 			
		endif
	return true

	function register(cpath,badmin)

		// this method tries to register the oleautoclient.
		// returns false, if registration failed

		extern clong LoadTypeLib(cptr,cptr culong) OleAut32
		extern clong RegisterTypeLibForUser(culong,cptr,cptr) OleAut32
		extern clong RegisterTypeLib(culong,cptr,cptr) OleAut32
		extern clong RegSetValueExW(chandle,cptr, culong,culong,cptr,culong) advapi32
		extern clong RegCreateKeyExW(chandle,cptr,clong,cptr,clong,culong,cptr,cptr culong, cptr culong) advapi32
		extern clong RegCloseKey(chandle) advapi32
		
		local ptlib,tlbfile,tmp,f,hkey,hkey1,rootkey,subval,codebase,admin
		
		if empty(badmin) 
			admin = false					//if dbase is started as administrator,this varaible
		else 									// can be true and the registration will be done in HKCLR
			admin = true					// when dbase is started normaly, admin must be false,
		endif									// if not , the registration will fail.
												// with false, the registration is for current user only.
		
		// clear the error-members in case of leftovers
		this.errorcode = 0
		this.errortext = "No Error"
	
		if empty(cpath)				// if path parameter is empty set it to the 
			tmp = program(0)			// directory where the program resides 
			tmp = left(tmp,rat("\",tmp))
		else
			if right(cpath,1) = "\"
				tmp = cpath
			else
				tmp = cpath+"\"	//no backslash at the end of the path so add one
			endif
		endif
		
		tlbfile = tmp+"mail_item.tlb"					// these hold the information
		dllfile = tmp+"smtp_mail_sender.dll"		// and code to be registered
		f = new file()
		
		if not f.exists(tlbfile)  	// check for tlb
			this.olecheck(1, "Can't find the .tlb file in the specified directory")
		endif
			
		if not f.exists(dllfile)  	// check for dll
			this.olecheck(1,"Can't find the .dll file in the specified directory")
		endif
		
		try
			ptlib = 0
			this.olecheck(loadtypelib(tlbfile,ptlib),"Could not open the Type-Library")
			if admin = false
				this.olecheck(RegisterTypeLibForUser(ptlib,tlbfile,null),"Could not register the Type-Library")
			else
				this.olecheck(RegisterTypeLib(ptlib,tlbfile,null),"Could not register the Type-Library")
			endif
			
			// if we get here, the registration of the tlb succeded,
			// now we must create the registry entries for the DLL
		
			if admin = false
				rootkey 		= 0x80000001 // HKEY_CURRENT_USER 
			else
				rootkey 		= 0x80000000 // HKEY_CLASSES_ROOT 
			endif
			codebase		= "file:///"+dllfile
			hkey 			= 0
			hkey1			= 0
			dispo			= 0
			subval		= ""
		
			// adapt the codebase to the registry form: slash instead of backslash
		
			do while "\" $ codebase
			codebase = codebase.stuff(codebase.indexof("\"),1,"/")
			enddo
			if admin = false
				tmp = "SOFTWARE\Classes\VdB_Mail.mail_item"+chr(0)
			else
				tmp = "VdB_Mail.mail_item"+chr(0)
			endif
			this.olecheck(RegCreateKeyExW(rootkey,tmp,0,null,0,0x202,null,hkey,dispo),"RegKey Creation failed")
			tmp = "VdB_Mail.mail_item"+chr(0)
			this.olecheck(RegSetValueExW(hkey,null,0,1,tmp,len(tmp)*2+2))
			tmp = "CLSID"+chr(0) ; hkey1 = 0
			this.olecheck(RegCreateKeyExW(hkey,tmp,0,null,0,0x202,null,hkey1,dispo),"RegKey Creation failed")
			tmp = "{1F56C5D3-FD59-32F0-A3EB-EE28305E53C7}"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,null,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegCloseKey(hkey1),"Closing error")
			this.olecheck(RegCloseKey(hkey),"Closing error")
			if admin = false
				tmp = "SOFTWARE\Classes\WOW6432Node\CLSID\{1F56C5D3-FD59-32F0-A3EB-EE28305E53C7}"+chr(0)
			else
				tmp = "WOW6432Node\CLSID\{1F56C5D3-FD59-32F0-A3EB-EE28305E53C7}"+chr(0)
			endif
			this.olecheck(RegCreateKeyExW(rootkey,tmp,0,null,0,0x202,null,hkey,dispo),"RegKey Creation failed")
			tmp = "VdB_Mail.mail_item"+chr(0)
			this.olecheck(RegSetValueExW(hkey,null,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")			
			tmp = "ProgId"+chr(0) ; hkey1 = 0
			this.olecheck(RegCreateKeyExW(hkey,tmp,0,null,0,0x202,null,hkey1,dispo),"RegKey Creation failed")
			tmp = "VdB_Mail.mail_item"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,null,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegCloseKey(hkey1),"Closing error")
			tmp = "Implemented Categories\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}"+chr(0) ; hkey1 = 0
			this.olecheck(RegCreateKeyExW(hkey,tmp,0,null,0,0x202,null,hkey1,dispo),"RegKey Creation failed")
			this.olecheck(RegCloseKey(hkey1),"Closing error")
			tmp = "InprocServer32"+chr(0) ; hkey1 = 0
			this.olecheck(RegCreateKeyExW(hkey,tmp,0,null,0,0x202,null,hkey1,dispo),"RegKey Creation failed")
			tmp = "mscoree.dll"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,null,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			tmp = "1.0.0.0"+chr(0) ; hkey = 0
			this.olecheck(RegCreateKeyExW(hkey1,tmp,0,null,0,0x202,null,hkey,dispo),"RegKey Creation failed")
			tmp = "Both"+chr(0)
			subval = "ThreadingModel"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			tmp = "VdB_Mail.mail_item"+chr(0)
			subval = "Class"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegSetValueExW(hkey,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			tmp = "SMTP_Mail_Sender, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null"+chr(0)
			subval = "Assembly"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegSetValueExW(hkey,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			tmp = "v2.0.50727"+chr(0)
			subval = "RuntimeVersion"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegSetValueExW(hkey,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			tmp = codebase+chr(0)
			subval = "CodeBase"+chr(0)
			this.olecheck(RegSetValueExW(hkey1,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegSetValueExW(hkey,subval,0,1,tmp,len(tmp)*2+2),"Could not assign a value to the RegKey")
			this.olecheck(RegCloseKey(hkey1),"Closing error")
			this.olecheck(RegCloseKey(hkey),"Closing error")			

		catch(oleexception e)
			return false
		endtry
		
		// if we get here, the registration of the DLL succeded,
		// now we try to instantiate the mail_item object again
		
		this.b_ok	= true // for internal test if mailitem could be instanced
	
		try
			this.mobj = new oleautoclient("vdb_mail.mail_item")
		catch(exception e)
			this.errorcode = e.code
			this.errortext = e.message 
			this.b_ok		= false
		endtry
	return this.b_ok
	
	function olecheck(errval,errtext)  // error-check for the registry functions
		this.errorcode = errval
		if errval <> 0
			this.errortext = errtext
			throw this.oleex		// if an error occurs, don't execute the rest
		endif
	return

endclass

Class Oleexception of Exception
Endclass
