

/* 

dBase Frame Control - dBL collection class - v 2.2 
---------------------------------------------------------------------


Program : dBCWnd.cc

Programmer : Greg Brzozowski GM+ (gmplus@o2.pl)

Last Modified : 01/09/2004

Written for.....: dB2K 0.x/dBase PLUS 2.x

Rev. History : 05/12/2003 -- Original

					14/12/2003 -- Fixed more bugs
               				  Added ToolBoxFx class	  
                             Changed some name and added property 
                             ToolBarCtrl and TolbarFx class

               22/12/2003 -- Changed ContainerFx class conception
                             Changed some method ToolbuttonFx class
                             Added AutoScroll() and AutoRange() method ScrollBarCtrl class
                             Added property to FrameCtrl,FrameAppCtrl class
                             Now used sizeable and more standard property MDI form

               15/01/2004 -- Added StatusBarAppCtrl and ProgressCtrl class

               20/01/2004 -- Added property to ToolbarFx class

               15/02/2004 -- Changed some method ToolbuttonFx class
               				  Added Toggle property to ToolbuttonFx and MenuFx
                             instead of twoState property - abnormally
                             dBCWnd class 

               15/06/2004 -- Added show() and hide() method 
               			  	  Added getSize() method to TolBoxFx class 
                             New class TreeItemFx and TreeViewFx   

               01/09/2004 -- New class NoteBookFx                      
                              
Dependencies:

   dBCWnd.dll
   dBCWnd.h

   csSrcFx.cc
   

Usage:

   set proc dBCWnd.cc additive
                                                            



Description:


   class dBCWndCtrl                              
   -----------------------------------------------------

   Properties:

   	hWnd 		 				- numeric value
      							  Controlled object handle

      attached					- logical value
      							  Whether the object is controlled

   Methods:

   	release()				- Releases an object from memory


   Description:

   	This non-window control base window class



   class FrameCtrl(frameObj) of dBCWndCtrl 
   -----------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

   	dockBarEdge	  			- logical value
      							  Whether the edge of the dock-bar window 
         								 
 		dockBarExpand    		- logical value
      							  Whether the dock-bar frame 
                             automatically resizes frame window	

 		dockBarHiding			- logical value
      							  Whether the dock-bar frame 
                             automatically hiding mini-frame window 
                             when owner frame window is being deactivated  

 		scrollBackground		- logical value
      							  Whether the frame background image scrolling                         
  
 		widthMin 				- numeric value
 		widthMax               Sizing range width of the frame client in pixels

 		heightMin  				- numeric value
 		heightMax          	  Sizing range height of the frame client in pixels

 		hScrollBar 				- object value <class ScrollBarCtrl>
      							  Horizontal scroll-bar controlled

 		vScrollBar           - object value <class ScrollBarCtrl>
      							  Vertical scroll-bar controlled 

 		hWndClient           - numeric value 
      							  Client window handle

 		frameObj             - object value
      							  Controlled object class


   Methods:
  	
     	attach()					- Sublcassed frame window

     	detach()					- Unsublassed frame window

     	recalc()					- Recalc frame window

      scroll(<nHorz expN>,<nVert expN>) 

      							- Scrolling the client area
                             parameters in pixels

      setRange(<whMin expN>,<htMin expN>,<whMax expN>,<htMax expN>)				

      							- Sets size range the client area
                             parameters in pixels	

     	release()				- Releases an object from memory

      
	Usage:

   	oForm = new Form()
      oForm.open()

   	oFrameCtrl = new FrameCtrl(oForm) 
      oFrameCtrl.attach()  

      oFrameCtrl = new FrameCtrl() 
      oFrameCtrl.hWnd = oForm.hWnd
      oFrameCtrl.attach() 

      oFrameCtrl.setRange(100,100)
      oFrameCtrl.setRange(0,0,500,500)

   

   Description:

   	Allow controlled window class: Form and SubForm  



   class FrameAppCtrl of FrameCtrl 
   -----------------------------------------------------
   
   Properties:

   	attached					- logical value
      							  Whether the object is controlled

      sysMenu              - logical value  
                             Whether the form's system menu icon and close icon are displayed when not MDI

      topMost              - logical value
                             Whether the frame window stays on top 

      smallTitle           - logical value
                             Whether the frame window has the smaller title-bar 

      moveable             - logical value
                             Whether the frame window is moveable

      sizeable             - logical value
                             Whether the frame window is sizeable

      minimize             - logical value
                             Whether the frame window can be minimized 

      maximize             - logical value
                             Whether the frame window can be maximized


   	dockBarEdge	  			- logical value
      							  Whether the edge of the dock-bar window 
         								 
 		dockBarExpand    		- logical value
      							  Whether the dock-bar frame 
                             automatically resizes frame window	

 		dockBarHiding			- logical value
      							  Whether the dock-bar frame 
                             automatically hiding mini-frame window 
                             when owner frame window is being deactivated  

 		widthMin 				- numeric value
 		widthMax               Sizing range width of the frame client in pixels

 		heightMin  				- numeric value
 		heightMax          	  Sizing range height of the frame client in pixels

 		toolBar 					- object value <class ToolBarAppCtrl>
      							  Standard tool-bar controlled

      statusBar            - object value <class StatusBarAppCtrl>
      							  Standard status-bar controlled

 		hWndClient           - numeric value 
      							  Client window handle

 		frameObj             - object value
      							  Controlled object class


   Methods:
	
     	attach()					- Sublcassed frame window

     	detach()					- Unsublassed frame window

     	recalc()					- Recalc frame window

      setRange(<whMin expN>,<htMin expN>,<whMax expN>,<htMax expN>)				

      							- Sets size range the client area
                             parameters in pixels	

     	release()				- Releases an object from memory

      
	Usage:

   	_app.frameCtrl = new FrameAppCtrl()       
      _app.frameCtrl.attach()
   	

   Description:

   	Controlled FrameWindow class 



   class ScrollBarCtrl of dBCWndCtrl 
   -----------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

 		visible					- logical value
      							  Whether a scroll-bar is visible

      type						- numeric value
      							  Automatically assign type scroll-bar
                                                 
 		rangeMin					- numeric value
 		rangeMax               Scroll range in pixels

 		position             - numeric value
      							  Scroll position in pixels	

 		step						- numeric value
      							  Scroll step value in pixels                 

 		frameObj             - object value
      							  Controlled object class

   
   Methods:

      setScroll(<pos expN>,<min expN>,<max expN>,<step expN>)			

      							- Sets the parameters of a scroll-bar
                             parameters in pixels	

      autoScroll()         - Scroll automatically to the focused window position

      autoRange()          - Sets automatically scroll range
                 
      getPos()					- Retrieves the current position of the scroll-box 	
    
      release()				- Releases an object from memory


	Usage:

   	oForm = new Form()
      
   	oFrameCtrl = new FrameCtrl(oForm)
      oFrameCtrl.vScrollBar = new ScrollBarCtrl()
      
      oFrameCtrl.vScrollBar.setScroll(0,0,100,10)
      oFrameCtrl.vScrollBar.setScroll(0,-10,100)
      oFrameCtrl.vScrollBar.setScroll(5)

      oFrameCtrl.attach()

      oFrameCtrl.vScrollBar.step = 20
      oFrameCtrl.vScrollBar.setScroll()


   Description:

   	Allow controlled standard scroll-bar window class: Form, SubForm, Container

      Displays scroll-bars only when needed when range value is zero
   	

       

   class ToolBarCtrl(dockObj) of dBCWndCtrl 
   -----------------------------------------------------

   Properties:
 	
   	attached					- logical value
      							  Whether the object is controlled
   
 		docked               - logical value
      							  Whether the tool-bar is docked	or floating

 		stretch              - logical value
      							  Whether the tool-bar is stretching		

      gripper              - logical value
      							  Whether the drag-box of the tool-bar window when docked
   
      caption              - logical value
      							  Whether the title-bar of the tool-bar window when docked
    							
      outerEdge            - logical value
      							  Whether the outer edge of the tool-bar window when docked

      innerEdge            - logical value
      							  Whether the inner edge of the client tool-bar window

      moveable             - logical value
      							  Whether the tool-bar is moveable

      sizeable             - logical value
      							  Whether the tool-bar is sizeable

      floatable       		- logical value
                             Whether the tool-bar is floatable when not docked
  
      rotatable            - logical value
      							  Whether the tool-bar automatic rotate 
                             when changes alignment of the docked frame
                           	 
      horizontable       	- logical value
      							  Whether allowed to docked horizontal alignment

      verticable       		- logical value
      							  Whether allowed to docked vertical alignment

 		alignment				- numeric value 
      							  Determines how the tool-bar docked to frame
                             alignment of the docked frame: 

                             		0 - top
                                 1 - left
                                 2 - right
                                 3 - bottom

      text						- string value
      							  Display text of the title-bar mini-frame
                             if tool-bar is floating

      dockTop              - numeric value
      dockLeft               Position value of the dock-bar window  
      							  to set docked tool-bar window in pixels	   						 

      dockWidth				- numeric value
      dockHeight             Size value to set docked tool-bar window in pixels

      floatTop             - numeric value
      floatLeft              Position value of the screen 
      							  to set mini-frame window in pixels

      floatWidth           - numeric value
      floatHeight            Size value to set floating tool-bar window in pixels

                                
      dockObj              - object value
      							  Controlled tool-bar object class

      frameObj             - object value
      							  Controlled frame object class	
   

   Methods:
                           
   	attach(<oFrame expO>) - Sublcassed tool-bar window 
      							   and docked to controlled frame window 	     							                           

      detach()             - Unsublcassed tool-bar window 
                             and undocked to controlled frame window 

      show()

      hide()

      setDock(<oFrame expO>) - Sets dock tool-bar to controlled frame window

      setPos(<left expN>,<top expN>,<width expN>,<height expN>,<state expN>)

   	                     - Sets position and size tool-bar window state:

                              	0 - Horizontal 
                                 1 - Vertical 
                                 2 - Floating 

      setText(<text expC>) - Sets display text of the title-bar mini-frame

      getState()				- Gets current state tool-bar 

      getPos()					- Gets current position and size tool-bar

      release()				- Releases an object from memory

                                     
	Usage:

   	oForm = new Form()
     
      oFrameCtrl = new FrameCtrl(oForm)    
      oFrameCtrl.attach()

   	oToolBar = new ToolBar()

   	oToolBarCtrl = new ToolBarCtrl(oToolBar)
      oToolBarCtrl.attach(oForm)

      oToolBarCtrl = new ToolBarCtrl()
      oToolBarCtrl.hWnd = oToolBar.hWnd
      oToolBarCtrl.attach(oForm)

      oToolBarCtrl.docked = false
      oToolBarCtrl.caption = true 
      oToolBarCtrl.setDock()

      oToolBarCtrl.setPos(0,0,100,25,0)
      oToolBarCtrl.setPos(1,1,50,25)
      oToolBarCtrl.setPos(false,false,100,25)
   	oToolBarCtrl.setPos(0,0)

      oToolBarCtrl.floatLeft = 100 
      oToolBarCtrl.setPos()

      oToolBarCtrl.getPos()

      ? oToolBarCtrl.floatLeft


   Description:

   	Allow controlled any window class

      Allow attached window class: Form, SubForm and FrameWindow



   class ToolBarAppCtrl of ToolBarCtrl 
   -----------------------------------------------------

   
   Properties:
 	
   	attached					- logical value
      							  Whether the object is controlled
   
 		docked               - logical value
      							  Whether the tool-bar is docked	or floating

 		stretch              - logical value
      							  Whether the tool-bar is stretching	      

      gripper              - logical value
      							  Whether the drag-box of the tool-bar window when docked
   
      caption              - logical value
      							  Whether the title-bar of the tool-bar window when docked
         							
      outerEdge            - logical value
      							  Whether the outer edge of the tool-bar window when docked

      innerEdge            - logical value
      							  Whether the inner edge of the tool-bar window                       	

      moveable             - logical value
      							  Whether the tool-bar is moveable

      sizeable             - logical value
      							  Whether the tool-bar is sizeable

      rotatable            - logical value
      							  Whether the tool-bar is rotatable 
                             if changes alignment of the docked frame	 
      
      floatable       		- logical value
                             Whether the tool-bar is floatable when not docked
                             	 
      horizontable       	- logical value
      							  Whether allowed to docked horizontal alignment

      verticable       		- logical value
      							  Whether allowed to docked vertical alignment
      
 		alignment				- numeric value 
      							  Determines how the tool-bar docked to frame
                             alignment of the docked frame: 

                             		0 - top
                                 1 - left
                                 2 - right
                                 3 - bottom

      text						- string value
      							  Display text of the title-bar mini-frame
                             if tool-bar is floating

      dockTop              - numeric value
      dockLeft               Position value of the dock-bar window  
      							  to set docked tool-bar window in pixels	   						 

      dockWidth				- numeric value
      dockHeight             Size value to set docked tool-bar window in pixels

      floatTop             - numeric value
      floatLeft              Position value of the screen 
      							  to set mini-frame window in pixels

      floatWidth           - numeric value
      floatHeight            Size value to set floating tool-bar window in pixels

                                
      frameObj             - object value
      							  Controlled frame object class	
   

   Methods:
                           
      setDock() 				- Sets Dock tool-bar to controlled frame window

      setPos(<left expN>,<top expN>,<width expN>,<height expN>,<state expN>)

   	                     - Sets position and size tool-bar window state:

                              	0 - Horizontal 
                                 1 - Vertical 
                                 2 - Floating 

      setText(<text expC>) - Sets display text of the title-bar mini-frame

      getState()				- Gets current state tool-bar 

      getPos()					- Gets current position and size tool-bar

      release()				- Releases an object from memory

                                     
	Usage:

    	_app.frameCtrl = new FrameAppCtrl()
      _app.frameCtrl.toolbar = new ToolBarAppCtrl()     
      _app.frameCtrl.attach()

      _app.frameCtrl.toolbar.stretch = true
      _app.frameCtrl.toolbar.setDock()

   
   Description:

   	Controlled default tool-bar Application class



  
   class StatusBarAppCtrl of dBCWndCtrl 
   -----------------------------------------------------

   
   Properties:
 	
   	attached					- logical value
      							  Whether the object is controlled
   
      progress             - object value <class ProgressCtrl>  							                  
                                
      frameObj             - object value
      							  Controlled frame object class	
   

   Methods:
                           
      setText(<text expC>) - Sets display text of the status-bar

      release()				- Releases an object from memory

                                     
	Usage:

    	_app.frameCtrl = new FrameAppCtrl()
      _app.frameCtrl.statusBar = new StatusBarAppCtrl()     
      _app.frameCtrl.attach()

      _app.frameCtrl.statusBar.setText("Proccess ...")
      
   
   Description:

   	Controlled default status-bar Application class



   
   class ProgressCtrl of dBCWndCtrl 
   -----------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

 		visible					- logical value
      							  Whether a scroll-bar is visible
                                           
 		rangeMin					- numeric value
 		rangeMax               Progress range

 		position             - numeric value
      							  Progress position

 		parent               - object value
      							  
   
   Methods:

      setRange(<nMin expN>,<nMax expN>)				

      							- Sets progress range

      setPos(<nPos expN>)  - Sets progress position
                 
      show(<bShow expL>)	- Sets progress show 	
    
      release()				- Releases an object from memory


	Usage:

   	_app.frameCtrl = new FrameAppCtrl()
      _app.frameCtrl.statusBar = new StatusBarAppCtrl()  

      _app.frameCtrl.statusBar.progress = new ProgressCtrl() 
      _app.frameCtrl.statusBar.progress.rangeMax = 100  
      _app.frameCtrl.statusBar.progress.position = 10

      _app.frameCtrl.attach()

      _app.frameCtrl.statusBar.progress.show(true)

      _app.frameCtrl.statusBar.progress.setRange(0,100)
      _app.frameCtrl.statusBar.progress.setPos(50)


   Description:

   


   
   class ToolBoxFx(oParent) of ToolBar 
   -----------------------------------------------------
  
   Properties:

   	attached					- logical value
      							  Whether the object is controlled

      transparent				- logical value
      							  Whether the tool-box has the same background color 
                             or image as the its own container
 
 		orientation				- numeric value 
      							  Sets tool-box orientation :                          

                             		0 - horizontal
                                 1 - vertical
                               
      btnsMixed				- logical value
      							  Whether the mixed different type of buttons

 		btnsStyle            - numeric value
      							  Sets extended style buttons :	

        									0 - default 
                                 1 - show text to the bottom of the bitmap 
                                 2 - show text to the right of the bitmap  

 		btnsWidth				- numeric value
      							  Sets button widths in the tool-bar control in pixels

      btnsPadding				- numeric value
      							  Sets the padding values are used to create a blank 
                             area between the edge of the button 
                             and the button's image and/or text	

      top              		- numeric value
      left               	  Position value of an object 
      							  relative to its container in pixels

      width						- numeric value
      height                 property is read-only getSize() method value

      aItems					- array value
                             Array tool-bar items creates automatically
                              
      parent             	- object value
      							  Parent object window class	
    
   Methods:
                           
  
   	attach(<oFrame expO>) - Sublcassed tool-bar window 
                              and docked to controlled frame window 

      detach()             - Unsublcassed tool-bar window 
                             and undocked to controlled frame window 

      recalc()             - Recalc tool-bar window

      show()

      hide()

      setStyle() 				- Sets the styles of a tool-bar

      setMetric() 			- Sets the metrics of a tool-bar

      setPos(<left expN>,<top expN>)

   	                     - Sets position in pixels

      getSize() 				- Gets current width or height in pixels

      release()				- Releases an object from memory


     
	Usage:

   	oForm = new Form()

      oToolBox = new ToolBox(oForm)
      oToolBox.attach()

      oToolBox.setPos(25,10)

      oToolBox.btnsStyle = 1
      oToolBox.orientation = 1
      oToolBox.setStyle()

      oToolBox.btnsPadding = 10
      oToolBox.setMetric()
    
   

   Description:

   	This class on a form

      Parent window of the tool-box - any window object class 
      

   


   class ToolBarFx of ToolBar 
   -----------------------------------------------------
  
   Properties:

   	attached					- logical value
      							  Whether the object is controlled
 
 		docked               - logical value
      							  Whether the tool-bar is docked	or floating

 		stretch              - logical value
      							  Whether the tool-bar is stretching

      gripper              - logical value
      							  Whether the drag-box of the tool-bar window when docked       							  

      caption              - logical value
      							  Whether the title-bar of the tool-bar window when docked
      							
      outerEdge            - logical value
      							  Whether the outer edge of the tool-bar window when docked

      innerEdge            - logical value
      							  Whether the inner edge of the tool-bar window                      		

      moveable             - logical value
      							  Whether the tool-bar is moveable

      sizeable             - logical value
      							  Whether the tool-bar is sizeable

      wrapable					- logical value
                             Whether the tool-bar is wrapable

      rotatable            - logical value
      							  Whether the tool-bar is rotatable 
                             if changes alignment of the docked frame	      								

      floatable       		- logical value
                             Whether the tool-bar is floatable when not docked

      adjustable       		- logical value
                             Whether the tool-bar is 

                             	 
      horizontable       	- logical value
      							  Whether allowed to docked horizontal alignment

      verticable       		- logical value
      							  Whether allowed to docked vertical alignment

 		alignment				- numeric value 
      							  Determines how the tool-bar docked to frame
                             alignment of the docked frame: 

                             		0 - top
                                 1 - left
                                 2 - right
                                 3 - bottom

      btnsMixed				- logical value
      							  Whether the mixed different type of buttons

 		btnsStyle            - numeric value
      							  Sets extended style buttons :	

        									0 - default 
                                 1 - show text to the bottom of the bitmap 
                                 2 - show text to the right of the bitmap  

 		btnsWidth				- numeric value
      							  Sets button widths in the tool-bar control in pixels

      btnsPadding				- numeric value
      							  Sets the padding values are used to create a blank 
                             area between the edge of the button 
                             and the button's image and/or text	

      dockTop              - numeric value
      dockLeft               Position value of the dock-bar window  
      							  to set docked tool-bar window in pixels	

      dockWidth				- numeric value
      dockHeight             Size value to set docked tool-bar window in pixels                         						 


      floatTop             - numeric value
      floatLeft              Position value of the screen 
      							  to set mini-frame window in pixels

      floatWidth           - numeric value
      floatHeight            Size value to set floating tool-bar window in pixels

      aItems					- array value
                             Array tool-bar items creates automatically
                              
      frameObj             - object value
      							  Controlled frame object class	
    
   Methods:
                           
  
   	attach(<oFrame expO>) - Sublcassed tool-bar window 
                              and docked to controlled frame window 

      detach()             - Unsublcassed tool-bar window 
                             and undocked to controlled frame window 

      recalc()             - Recalc tool-bar window

      show()

      hide()

      setDock(<oFrame expO>) - Sets dock tool-bar to controlled frame window

      setStyle() 				- Sets the styles of a tool-bar

      setMetric() 			- Sets the metrics of a tool-bar

      setPos(<left expN>,<top expN>,<width expN>,<height expN>,<state expN>)

   	                     - Sets position and size tool-bar window state:

                              	0 - Horizontal
                                 1 - Vertical
                                 2 - Floating 

      getState()				- Gets current state tool-bar 

      getPos()					- Gets current position and size tool-bar

      release()				- Releases an object from memory


     
	Usage:

   	oForm = new Form()
     
      oFrameCtrl = new FrameCtrl(oFrame)    
      oFrameCtrl.attach()

   	oToolBar = new ToolBarFx()
      oToolBar.attach(oForm)    

      oToolBar.attach(_app.FrameWin)
      oToolBar.setDock(oForm)

      oToolBar.wrapable = true
      oToolBar.setDock()

      oToolBar.btnStyle = 2
      oToolBar.setStyle()

      oToolBar.onUpdate = class::onUpdateToolBarFx

      fun onUpdateToolBarFx

          this.getState()
       
      return
   

   Description:

      This class inherit methods class ToolBarCtrl

      Allow attached window class: Form, SubForm and FrameWindow




   class ToolButtonFx(oParent) of Toolbutton(oParent) 
   -----------------------------------------------------

   Properties:

      checked					- logical value
      							  Whether the tool-button is checked

      group                - logical value
      							  Whether the tool-button is grouped	

      grayed               - logical value
                             Whether the tool-button is grayed

      toggle               - logical value
      							  Whether the tool-button displays two-state check button

      autoSize             - logical value
      							  Whether the tool-button automatically size	

      dropDown             - logical value
      							  Whether the tool-button drop-down style	

      dropStyle				- numeric value
      							  The tool-button drop-down style:	

      							  		0 - default
                                 1 - whole drop-down

      text						- string value
      							  Display text of the tool-button

      textTip              - string value
      							  Display text of the tool-tip	

      textStatus           - string value
      							  Display text of the status-bar	

      id                   - numeric value
      							  Automatically assign id 
 
      idGroup					- numeric value
      							  Automatically assign group id 

      idSelMenu            - numeric value
      							  Default choice menu id	
 
      hMenu						- numeric value
                             Handle to popup-menu 

      aItems               - array value
                             Array tool-button items creates automatically


   Methods:

   	setStyle()				- Sets Common tool-button style

      setState()           - Sets Common tool-button state

      setCheck(<check expL>) - Sets Common tool-button state check

      setMenu(<menu expN>) - Sets handle popup-menu

      setText(<text expC>) - Sets display text of the tool-button

      setTextTip(<text expC>) - Sets display text of the tool-tip

      setTextStatus(<text expC>) - Sets display text of the status-bar

      getChecked()         - Gets the checked state of the tool-button
                             or id checked tool-button when is grouped

      getSelMenu()			- Gets selected menu-item id 
                             when tool-button is dropdown style
                             and generate onClick event MenuFx class

   	release()				- Releases an object from memory

   	      
	Usage:

   	oForm = new Form()

   	oToolBar = new ToolBarFx(oForm)
      oToolBar.button = new ToolButtonFx(oToolBar)
      oToolBar.attach()

      oToolBar.button.grayed = false
      oToolBar.button.checked = true
      oToolBar.button.setState()

      oToolBar.button.autoSize = true
      oToolBar.button.dropDown = true
      oToolBar.button.toggle = false
      oToolBar.button.group = false
      oToolBar.button.setStyle() 
  
      oToolBar.button.group = true
      oToolBar.button.checked = true
      oToolBar.button.onClick = {;this.seCheck()}

      ? oToolBar.button.getChecked()
      
      oToolBar.button.setTextTip("bla bla blaa" + chr(10) + "multi-line text")
     

   Description:

   	Extended style of the common tool-button

      Parent object class : ToolBarFx




   class MenuFx(oParent,cName) 
   -----------------------------------------------------

   Properties:
  
   	enabled              - logical value
      							  Whether the menu-item is enabled

      checked              - logical value
      							  Whether the menu-item is checked

      group                - logical value
      							  Whether the menu-item is grouped

      toggle               - logical value
      							  Whether the menu-item displays two-state check-box

      separator            - logical value
      							  Whether the menu-item is a separator type 

      menuBreak            - logical value
                             Whether the menu-item columns separate 
                             vertical line 
     
      subMenu					- logical value
      							  Whether the menu-item have submenu-items 
                             Automatically setting                                                       
                             
      text                 - string value
      							  Display text of the menu-item

      shortCut             - string value
      							  Display short-cut text of the menu-item

      textStatus           - string value
      							  Display text of the status-bar

      name						- string value
      							  The name of the menu item	

      id                   - numeric value
      							  Automatically assign id 

      idGroup              - numeric value
      							  Automatically assign group id 

      hMenu						- numeric value
      							  Handle to popup-menu	

      aItems               - array value
                             Array tool-button items creates automatically
                          	
      parent					- object value
      							  The menu-items immediate container	


   Events:

   	onClick					- After the menu-item is select
                             Manually generate event

   Methods:

      create()             - Creates menu-item

      destroy()            - Destroy menu-item

      createMenu()         - Creates popup-menu
                           
      destroyMenu()        - Destroy popup-menu   

      reindex()            - Reindex menu id and menu group id

      next()               - Gets next object menu-item

      setState()           - Sets menu-item state

      setType()            - Sets menu-item type

      setCheck(<check expL>) - Sets menu-item state check

      setSubMenu(<menu expN>) - Sets handle popup-menu

      setText(<text expC>) - Sets display text of the menu-item

      setShortCut(<text expC>) - Sets display short-cut text of menu-item

      setTextStatus(<text expC>) - Sets display text of the status-bar
   	
      release()            - Releases an object from memory

    
	Usage:

   	oForm = new Form()

   	oToolBar = new ToolBarFx(oForm)

   	oToolBar.button = new ToolButtonFx(oToolBar)
      oToolBar.button.dropdown = true

      oToolBar.button.menu = new MenuFx(oToolBar.button)

      oToolBar.button.menu.menu = new MenuFx(oToolBar.button.menu)

      oToolBar.attach(oForm)

      oToolBar.button.menu.enabled = true
      oToolBar.button.menu.checked = false
      oToolBar.button.menu.setState()

      oToolBar.button.menu.separator = false
      oToolBar.button.menu.menuBreak = false
      oToolBar.button.menu.group = false
      oToolBar.button.menu.setType()

      oToolBar.button.menu.group = true
      oToolBar.button.menu.reindex()

      oToolBar.button.menu.setShortCut("Ctrl+N")

      oToolBar.button.menu.menu.destroy()
      oToolBar.button.menu.menu.create()

      oToolBar.button.menu.release()
      oToolBar.button.menu = new MenuFx(oToolBar.button)
      oToolBar.button.menu.onClick = {;? "Clicked"}

      oToolBar.button.onClick = {;? this.getSelMenu()}



   Description:

   	This class object represent the individual menu-items

      Parent object class : ToolButtonFx or another MenuFx

      Dynamic menu




   class FormFx of Form
   -----------------------------------------------------
   class SubFormFx of SubForm
   -----------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

   	dockBarEdge	  			- logical value
      							  Whether the edge of the dock-bar window 
         								 
 		dockBarExpand    		- logical value
      							  Whether the dock-bar frame 
                             automatically resizes frame window	

 		dockBarHiding			- logical value
      							  Whether the dock-bar frame 
                             automatically hiding mini-frame window 
                             when owner frame window is being deactivated  

 		scrollBackground		- logical value
      							  Whether the frame background image scrolling                         
  
 		widthMin 				- numeric value
 		widthMax               Sizing range width of the frame client in pixels

 		heightMin  				- numeric value
 		heightMax          	  Sizing range height of the frame client in pixels

 		hScrollBar 				- object value <class ScrollBarCtrl>
      							  Horizontal scroll-bar controlled 

 		vScrollBar           - object value <class ScrollBarCtrl>
      							  Vertical scroll-bar controlled 


   Methods:
  	
     	attach()					- Sublcassed frame window

     	detach()					- Unsublassed frame window

     	recalc()					- Recalc frame window

      scroll(<nHorz expN>,<nVert expN>) 

      							- Scrolling the client area
                             parameters in pixels

      setRange(<whMin expN>,<htMin expN>,<whMax expN>,<htMax expN>)				

      							- Sets size range the client area
                             parameters in pixels	

     	release()				- Releases an object from memory
     


   Usage:

   	oForm = new FormFx()

      oForm.heightMin = 200
      oForm.attach()


   Description:

   	This class inherit methods class FrameCtrl



   
   class ContainerFx(oParent) of Container(oParent)
   -----------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

     	dockBarEdge	  			- logical value
      							  Whether the edge of the dock-bar window   
     
 		widthMin 				- numeric value
 		heightMin              Sizing range the frame client in pixels

      curPage              - numeric value
                             Indicate active container page 

      client               - object value
                             Define client object

 		hScrollBar 				- object value <class ScrollBarCtrl>
      							  Horizontal scroll-bar controlled when not define client

 		vScrollBar           - object value <class ScrollBarCtrl>
      							  Vertical scroll-bar controlled when not define client                             								 

    
   Events:

      onPage               - After the container page has changes
                             Manually generate event        

   Methods:
 
     	attach()					- Sublcassed frame window

     	detach()					- Unsublassed frame window

     	recalc()					- Recalc frame window

      scroll(<nHorz expN>,<nVert expN>) 

      							- Scrolling the client area
                             parameters in pixels

      setRange(<whMin expN>,<htMin expN>)				

      							- Sets size range the client area parameters in pixels	

      setPage(<nPage expN>) - Sets container page and generate onPage event


     	release()				- Releases an object from memory
     
 
       
   Usage:

   	oForm = new FormFx()
      oForm.containerFx = new ContainerFX(oForm)
   
      oForm.containerFx.client = new ListBox(oForm.containerFx)
      oForm.containerFx.attach()

      or

      oForm.containerFx.entryfield1 = new Entryfield(oForm.containerFx)
      oForm.containerFx.entryfield2 = new Entryfield(oForm.containerFx)
      oForm.containerFx.vScrollBar = new ScrollBarCtrl()
      oForm.containerFx.attach()

      oForm.containerFx.setPage(2)


   Description:

   	This class inherit methods class FrameCtrl

   	Alternative to class SubForm,NoteBook 


   


Variations:


	Example 1:

   Creates TreeView object class and docked 
   to frame window Application class :

	
    	 oForm = new Form()
       oForm.mdi = true
       oForm.visible = false
     
       oForm.oTreeView = new TreeView(oForm)
       oForm.oTreeView.anchor = 6 // container

       oForm.open()
       
       oToolBarCtrl = new ToolBarCtrl(oForm)
       oToolBarCtrl.stretch = true
       oToolBarCtrl.alignment = 1 // to left

       oToolBarCtrl.attach(_app.frameWin)

       oForm.visible = true


    Example 2:

    Creates ContainerX object class 
    contained ListBox class object 
    and docked tool-bar class ToolBarFx :


       oContainer = ContainerX(oParent) 
       oContainer.client = new ListBox(oContainer.client)
       oContainer.attach()

       oToolBar = new ToolBarFx()
       oToolBar.style = 2 // show text
       oToolBar.alignment = 0 // to top

       oToolBar.button1 = new ToolButtonFx(oToolBar)
       oToolBar.button1.text = "Add"

       oToolBar.button2 = new ToolButtonFx(oToolBar)
       oToolBar.button2.text = "Delete"

       oToolBar.attach(oContainer)


    Example 3:

    Creates FormFx class object and docked 
    to other FormFx class window :


       oForm1 = new FormFx()
       oForm1.mdi = true
       oForm1.open()

       oForm1.attach()

       oToolBar = new ToolBarFx()
       oToolBar.alignment = 2 // to right
       oToolBar.attach(oForm1)

       oForm2 = new FormFx()
       oForm2.mdi = true
       oForm2.open()

       oForm2.attach()

       oToolBarCtrl = new ToolBarCtrl(oForm1)
       oToolBarCtrl.alignment = 1 // to left

       oToolBarCtrl.attach(oForm2)






  class TreeViewFx(oParent) of TreeView(oParent) custom
  -----------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

		iImage					- numeric value
		iSelectedImage         Number index tree-view image-list


   Events:
 
   Methods:

      attach()					- Sublcassed frame window

     	detach()					- Unsublassed frame window

 
   	addImage(<cSource expC>)		

      							- Adds an image to an image-list

 
   	setImageSize(<nSize expN>)

      							- Sets image size in pixels

   	reloadImages()			- Reloaded images


  
   Usage:

   	oTree = new TreeViewFx(oForm)
     

   Description:

   	The item images in a TreeViewFx class showed better quality 
      (device-dependent color bits)

      Power scalable and adds image file to tree-view image-list 
      and assigns to tree-item used image-list index 
      (iImage, iSelectedImage)
 



  class TreeItemFx(oParent) of TreeItem(oParent) custom
  -----------------------------------------------------

   Properties:

 		iImage					- numeric value
		iSelectedImage         Number index tree-view image-list

      treeObj             	- object value
      							  Tree-view object class	
  

   Events:

   Methods:
   
   	reloadImages()			- Reloaded images

 
   Usage:

   	oTree = new TreeViewFx(oForm)
      oTree.oItem = new TreeItemFx(oTree)
     

   Description:

   	Parent object class : TreeViewFx, TreeItemFx





  class NoteBookFx(oParent) of  NoteBook(oParent) custom
  ------------------------------------------------------

   Properties:

   	attached					- logical value
      							  Whether the object is controlled

		imageSize				- numeric value
                             Image size in pixels

 		images					- object value	
      							  Image array contains the image sources	

   Events:
 
   Methods:

      attach()					- Sublcassed frame window

     	detach()					- Unsublassed frame window

 
 
   Usage:

   	oNoteBook = new NoteBookFx(oForm)

      oNoteBook.dataSource = 'ARRAY {"First Tab","Second Tab"}'

      oNoteBook.images["First Tab"] = "filename tab1.ico"
      oNoteBook.images["2"] = "filename tab2.ico"
     

   Description:

 

--------------------------------------------------------------*/



#include dBCWnd.h



class dBCWndCtrl
***************************************************
 this.baseClassName = "DBCWNDCTRL" 
 this.className = "DBCWNDCTRL"

 this.attached = false  

 this.hWnd = 0  

 
 function attachFrame(dFlags)
 **************************************************
  if type("DBCWND_AttachFrame") # "FP"  
     extern CLOGICAL DBCWND_AttachFrame(CHANDLE,CULONG) dbCWnd.dll from "AttachFrame"
  endif

  return DBCWND_AttachFrame(this.hWnd,dFlags)


 function detachFrame()
 **************************************************
  if type("DBCWND_DetachFrame") # "FP" 
     extern CLOGICAL DBCWND_DetachFrame(CHANDLE) dbCWnd.dll from "DetachFrame"
  endif

  return DBCWND_DetachFrame(this.hWnd)


 function recalcFrame()
 **************************************************                                            
  if type("DBCWND_RecalcFrame") # "FP" 
     extern CLOGICAL DBCWND_RecalcFrame(CHANDLE) dbCWnd.dll from "RecalcFrame"
  endif

  return DBCWND_RecalcFrame(this.hWnd)


 function setDockBar(hWndOw,xPos,yPos,cxSize,cySize,dFlags,pData,sFlags)
 *************************************************************************   
  if type("DBCWND_SetDock") # "FP" 
     extern CLOGICAL DBCWND_SetDock(CHANDLE,CHANDLE,CINT,CINT,CUINT,CUINT,CULONG,CPTR,CUINT) dbCWnd.dll  from "SetDock"
  endif

  return DBCWND_SetDock(this.hWnd,hWndOw,xPos,yPos,cxSize,cySize,dFlags,pData,sFlags)


 function unDockBar()
 **************************************************   
  if type("DBCWND_UnDock") # "FP" 
     extern CLOGICAL DBCWND_UnDock(CHANDLE) dbCWnd.dll from "UnDock"
  endif

  return DBCWND_UnDock(this.hWnd)


 function setToolBar(nData1,nData2,pData,sFlags)
 *****************************************************   
  if type("DBCWND_SetToolBar") # "FP" 
     extern CLOGICAL DBCWND_SetToolBar(CHANDLE,CUINT,CULONG,CPTR,CUINT) dbCWnd from "SetToolBar"
  endif

  return DBCWND_SetToolBar(this.hWnd,nData1,nData2,pData,sFlags)


 function setStatusBar(nMin,nMax,nPos,pData,sFlags)
 ********************************************************
  if type("DBCWND_SetStatusBar") # "FP" 
     extern CLOGICAL DBCWND_SetStatusBar(CHANDLE,CINT,CINT,CINT,CPTR,CUINT) dbCWnd from "SetStatusBar"
  endif

  return DBCWND_SetStatusBar(this.hWnd,nMin,nMax,nPos,pData,sFlags)


 function setScrollBar(nMin,nMax,nPos,nStep,sFlags) 
 ********************************************************       
  if type("DBCWND_SetScrollBar") # "FP" 
     extern CLOGICAL DBCWND_SetScrollBar(CHANDLE,CINT,CINT,CINT,CINT,CUINT) dbCWnd from "SetScrollBar"
  endif

  return DBCWND_SetScrollBar(this.hWnd,nMin,nMax,nPos,nStep,sFlags)


 function setClientRange(hWnd,cxMin,cyMin,cxMax,cyMax,sFlags)
 *************************************************************
  if type("DBCWND_SetClientRange") # "FP" 
     extern CLOGICAL DBCWND_SetClientRange(CHANDLE,CUINT,CUINT,CUINT,CUINT,CUINT) dbCWnd from "SetClientRange"
  endif

  return DBCWND_SetClientRange(hWnd,cxMin,cyMin,cxMax,cyMax,sFlags)


 function setToolMenu(hMenu,nData1,nData2,pData,sFlags)
 *******************************************************
  if type("DBCWND_SetToolMenu") # "FP" 
     extern CLOGICAL DBCWND_SetToolMenu(CHANDLE,CUINT,CULONG,CPTR,CUINT) dbCWnd from "SetToolMenu"
  endif

  return DBCWND_SetToolMenu(hMenu,nData1,nData2,pData,sFlags)


 function setTreeView(hWnd,nData1,nData2,nData3,sFlags)
 *************************************************************
  if type("DBCWND_SetTreeView") # "FP" 
     extern CINT DBCWND_SetTreeView(CHANDLE,CULONG,CULONG,CULONG,CUINT) dbCWnd from "SetTreeView"
  endif

  return DBCWND_SetTreeView(hWnd,nData1,nData2,nData3,sFlags)


 function setNoteBook(nData1,nData2,sFlags)
 *************************************************************
  if type("DBCWND_SetNoteBook") # "FP" 
     extern CLOGICAL DBCWND_SetNoteBook(CHANDLE,CULONG,CULONG,CUINT) dbCWnd from "SetNoteBook"
  endif

  return DBCWND_SetNoteBook(this.hWnd,nData1,nData2,sFlags)

  
 function attachClass(dFlags)
 **************************************************
  if type("DBCWND_AttachClass") # "FP"  
     extern CLOGICAL DBCWND_AttachClass(CHANDLE,CULONG) dbCWnd from "AttachClass"
  endif

  return DBCWND_AttachClass(this.hWnd,dFlags)


 function detachClass()
 **************************************************
  if type("DBCWND_DetachClass") # "FP" 
     extern CLOGICAL DBCWND_DetachClass(CHANDLE) dbCWnd from "DetachClass"
  endif

  return DBCWND_DetachClass(this.hWnd)
                                                 

 function release
 **************************************************
  release object this

 return



endclass



class FrameCtrl(frameObj) of dBCWndCtrl custom
***************************************************
 this.className = "FRAMECTRL"

 this.sysMenu = true
 this.topMost = false
 this.thickFrame = true
 this.smallTitle = false
 
 this.moveable = true
 this.sizeable = true
 this.minimize = true
 this.maximize = true

 this.dockBarEdge = true
 this.dockBarExpand = false
 this.dockBarHiding = false

 this.scrollBackground = true
  
 this.widthMin = 0
 this.widthMax = 0 

 this.heightMin = 0 
 this.heightMax = 0

 this.hScrollBar = Null
 this.vScrollBar = Null

 this.hWndClient = 0

 this.frameObj = frameObj


 
 function attach
 ******************************************************* 
  local obj

  if not this.attached 

     if this.className == "FRAMECTRL" and this.hWnd == 0

        if type("this.frameObj") == "O"	

           this.hWnd = this.frameObj.hWnd       
        else 
           return false	    
        endif

        obj = this.frameObj     	
     else
        obj = (this)                  	          
     endif 

  endif    
                                                                                                    
  if dBCWndCtrl::attachFrame(this.getFlags())

     if not this.attached

     	  this.attached = true  

        if type("WINAPI_GetDlgItem") # "FP"   
    		  extern CHANDLE WINAPI_GetDlgItem(CHANDLE,CINT) user32 from "GetDlgItem"
 		  endif

        hWndClient = WINAPI_GetDlgItem(obj.hWnd,ID_CLIENT)  

        if this.hWndClient # hWndClient
           this.hWndClient = hWndClient
        endif   

        this.setRange()    
  
        if this.hScrollBar # Null
           this.hScrollBar.attach(obj,0)
        endif

        if this.vScrollBar # Null
           this.vScrollBar.attach(obj,1)
        endif                  

     endif

     this.recalc()

     return true

  endif

  return false   



 function detach
 **************************************************

  if this.attached
     this.attached = false

 	  return dBCWndCtrl::detachFrame()

  endif

 return false


 function recalc
 **************************************************
 return dBCWndCtrl::recalcFrame()


 function scroll(nHorz,nVert)
 **************************************************
  local bScroll

  bScroll = true
 	       
  if this.hScrollBar # Null
     bScroll = this.hScrollBar.setScroll(nHorz)
  endif

  if this.vScrollBar # Null
     bScroll = this.vScrollBar.setScroll(nVert)
  endif

 return bScroll


   
 function setRange(nWhMin,nHtMin,nWhMax,nHtMax)
 ***********************************************
  local flags,bDef

   flags = 0
   bDef = true

   if type("argvector(4)") == "N" and;
   	type("argvector(3)") == "N"

      flags = bitor(flags,STS_MAX)
      bDef = false
    
      this.widthMax = nWhMax	
      this.heightMax = nHtMax    
   endif

   if type("argvector(2)") == "N" and;
   	type("argvector(1)") == "N"

      flags = bitor(flags,STS_MIN)
      bDef = false
    
      this.widthMin = nWhMin	
      this.heightMin = nHtMin    	
   endif

   if (this.widthMax > 0 and this.widthMax < this.widthMin) or;
      (this.heightMax > 0 and this.heightMax < this.heightMin)
     
      return false
   endif

  if bDef
     flags = bitor(flags,STS_ALL)
  endif
 
  return dBCWndCtrl::setClientRange(this.hWndClient,;
                               this.widthMin,this.heightMin,;
                               this.widthMax,this.heightMax,flags)

  

 function getFlags
 ***********************************************
  local flags,obj

  flags = 0

  obj = iif(type("this.frameObj") == "O",this.frameObj,(this))
 
  if obj.baseClassName == "FORM"
     flags = bitor(flags,iif(obj.mdi,CW_TYPE_MDI,CW_TYPE_SDI))
  
  elseif obj.baseClassName == "SUBFORM"
     flags = bitor(flags,CW_TYPE_SDI)   
     
  elseif obj.baseClassName == "FRAMEWINDOW" 
     flags = bitor(flags,CW_TYPE_APP)

  endif 
  
  if this.sysMenu
     flags = bitor(flags,CW_STYLE_SYSMENU) 
  endif

  if this.topMost
     flags = bitor(flags,CW_STYLE_TOPMOST) 
  endif

  if this.smallTitle
     flags = bitor(flags,CW_STYLE_TOOLWND) 
  endif

  if this.thickFrame
     flags = bitor(flags,CW_STYLE_SIZEBOX) 
  endif

  if this.moveable
     flags = bitor(flags,CW_ALLOW_MOVEABLE) 
  endif
  
  if this.sizeable
     flags = bitor(flags,CW_ALLOW_SIZEABLE)
  endif

  if this.minimize
     flags = bitor(flags,CW_ALLOW_MINIMIZE)
  endif

  if this.maximize
     flags = bitor(flags,CW_ALLOW_MAXIMIZE)
  endif

  if this.dockBarEdge
     flags = bitor(flags,DBR_STYLE_OUTEDGE)
  endif

  if this.dockBarExpand
     flags = bitor(flags,DBR_STYLE_EXPAND)
  endif

  if this.dockBarHiding
     flags = bitor(flags,DBR_STYLE_HIDING)
  endif

  if not this.scrollBackground
     flags = bitor(flags,SBR_STYLE_NOBKGND)
  endif

  return flags

  
 function release
 **************************************************
  
  if this.attached
     this.detach()
  endif

  if this.hScrollBar # Null
     this.hScrollBar.release()
     this.hScrollBar = Null
  endif

  if this.vScrollBar # Null
     this.vScrollBar.release()
     this.vScrollBar = Null
  endif

  if this.className == "FRAMECTRL"

     dBCWndCtrl::release()

  endif

 return



endclass




class FrameAppCtrl of FrameCtrl custom
***************************************************
 this.className = "FRAMEAPPCTRL"

 this.toolBar = Null
 this.statusBar = Null

 
 PROTECT hScrollBar,vScrollBar,scroll,;
 			scrollBackground,getFlags



 function attach
 *********************************************** 

  if this.attached
     return false
  endif

  this.frameObj = _app.frameWin
  this.hWnd = _app.frameWin.hWnd

  //this.hWndClient = WINAPI_GetDlgItem(this.hWnd,ID_CLIENT)

  if FrameCtrl::attach()

  	  if this.toolBar # Null
     	  this.toolBar.hWnd = HWND_STDTBAR
     	  this.toolBar.frameObj = this.frameObj	
        this.toolBar.setDock()
  	  endif

     if this.statusBar # Null
     	  this.statusBar.hWnd = WINAPI_GetDlgItem(this.hWnd,ID_STATBAR)
     	  this.statusBar.frameObj = this.frameObj
        this.statusBar.attach()
  	  endif

     return true

  endif

 return false


 
 function getFlags
 ***********************************************
  return FrameCtrl::getFlags()


 function release
 **************************************************

  if this.attached
     this.detach()
  endif

  if this.toolBar # Null
     this.toolBar.release()
  endif

  if this.statusBar # Null
     this.statusBar.release()
  endif
    
  dBCWndCtrl::release()

 return


endclass




class ScrollBarCtrl of dBCWndCtrl custom
***************************************************
 this.className = "SCROLLBARCTRL"

 this.visible = true

 this.type = 0 // 0 - Horizontal, 1 - Vertical
                                                 
 this.rangeMin = 0
 this.rangeMax = 0

 this.position = 0
 this.step = 10

 this.frameObj = Null



 function attach(frameObj,nType)
 ***********************************************

  if type("argvector(1)") == "O"

     this.frameObj = frameObj
     this.type = nType
     this.hWnd = frameObj.hWndClient

     return this.setScroll() 
  endif

 return false


 function detach
 ***********************************************

  if this.attached
 	  return this.setScroll()
  endif

 return false



 function setScroll(nPos,nMin,nMax,nStep)
 ***********************************************     
  local flags

  flags = iif(this.type == 0,SSB_HORZ,SSB_VERT)

  if this.visible and this.frameObj # Null

     if argcount() > 0

         if type("argvector(1)") == "N"
            flags = bitor(flags,SSB_POS)
                  
            this.position = nPos
         endif

         if type("argvector(2)") == "N"
            flags = bitor(flags,SSB_MIN)

            this.rangeMin = nMin
         endif

         if type("argvector(3)") == "N"
            flags = bitor(flags,SSB_MAX)
         
            this.rangeMax = nMax
         endif

         if type("argvector(4)") == "N"
            flags = bitor(flags,SSB_STEP)
                    
            this.step = nStep
         endif             

     else
        flags = bitor(flags,SSB_ALL)
                    
     endif

     if this.rangeMin == 0 or this.rangeMax == 0
        flags = bitor(flags,SSB_AUTO)
     endif
      
     if this.rangeMin > this.rangeMax or;
        this.rangeMin > this.position or;
        this.rangeMax < this.position

        return false
     endif
      
  else
      flags = bitor(flags,SSB_HIDE)

  endif
 
  this.attached = false

     
  if dBCWndCtrl::setScrollBar(this.rangeMin,this.rangeMax,;
                         		this.position,this.step,flags)
      
     this.attached = this.visible
    
     return true
  endif 
  
 return false


 function autoScroll
 ***********************************************     
  local flags
    
  if this.visible and this.frameObj # Null

     flags = iif(this.type == 0,SSB_HORZ,SSB_VERT)    
     flags = bitor(flags,SSB_POS)
     flags = bitor(flags,SSB_AUTO)
                 
     return dBCWndCtrl::setScrollBar(0,0,0,0,flags)
      
  endif  
  
 return false



 function autoRange
 ***********************************************     
  local flags

  if this.visible and this.frameObj # Null

     flags = iif(this.type == 0,SSB_HORZ,SSB_VERT)    
     flags = bitor(flags,SSB_RANGE)
     flags = bitor(flags,SSB_AUTO)
                 
     return dBCWndCtrl::setScrollBar(0,0,0,0,flags)
      
  endif  
  
 return false


 function getPos
 ***********************************************  

  if type("WINAPI_GetScrollPos") # "FP"   
     extern CINT WINAPI_GetScrollPos(CHANDLE,CINT) user32 from "GetScrollPos"
  endif

  this.position = WINAPI_GetScrollPos(this.hWnd,this.type)

 return this.position
  
 
endclass




class ToolBarCtrl(dockObj) of dBCWndCtrl custom
***************************************************
 this.className = "TOOLBARCTRL"

 this.docked = true

 this.stretch = false

 this.gripper = true
 this.caption = false
 this.outerEdge = true
 this.innerEdge = false

 this.moveable = true
 this.sizeable = true
 this.rotatable = true
 this.floatable = true
 
 this.horizontable = true
 this.verticable = true
 
 this.alignment = 0

 this.dockTop = 0
 this.dockLeft = 0
 this.dockWidth = 0
 this.dockHeight = 0

 this.floatTop = 0
 this.floatLeft = 0
 this.floatWidth = 0
 this.floatHeight = 0

 this.text = ""

 this.dockObj = dockObj
 this.frameObj = Null

 this.struct = Null


 //PROTECT struct//,getFlags


 function attach(frameObj)
 ********************************************
 
  if type("argvector(1)") == "O"

     this.frameObj = frameObj  

     if type("this.dockObj") == "O" or this.hWnd > 0

  	     return this.setDock() 
  	  endif
  endif

  return false  
 

 function detach
 ********************************************  

  if this.attached
     this.attached = false

 	  return dBCWndCtrl::unDockBar()

  endif

 return false

 
 

  function setDock(frameObj)
 ******************************************** 
  local flags,nLeft,nTop,nWidth,nHeight

  flags = 0

  if this.alignment == 0 or this.alignment == 3
     if not this.horizontable
        return false
     endif

     flags = SD_POS_HORZ

  elseif this.alignment == 1 or this.alignment == 2
     if not this.verticable
        return false
     endif

     flags = SD_POS_VERT
  endif

  if not this.docked
     flags = SD_POS_FLOAT
  endif
    
  if type("argvector(1)") == "O" or not this.attached
 
 	  if not this.attached
     	
     	  if this.className == "TOOLBARCTRL"
     	  
        	  if type("this.dockObj") == "O" and;
           	  this.dockObj.hWnd > 0
           	  this.hWnd = this.dockObj.hWnd 
                 
           elseif this.hWnd == 0
        	  	  return false
           endif  

           if not this.text == ""
           	  this.setText()
           endif                    
        endif
     else
     	  this.frameObj = frameObj                         
     endif    
         
     if this.struct == Null
        this.struct = space(10)
     endif

     flags = bitor(flags,SD_DOCK)        
  endif

  if this.docked
     nTop = this.dockTop
     nLeft = this.dockLeft
     nWidth = this.dockWidth
     nHeight = this.dockHeight
  else    
     nTop = this.floatTop 
     nLeft = this.floatLeft  
     nWidth = this.floatWidth
     nHeight = this.floatHeight 
  endif
 
  flags = bitor(flags,SD_POS)	
  flags = bitor(flags,SD_SIZE)
  flags = bitor(flags,SD_FLAGS)
  flags = bitor(flags,SD_DOCK_RECALC)

    
  if dBCWndCtrl::setDockBar(this.frameObj.hWnd,;
                            nLeft,nTop,nWidth,nHeight,;
                            this.GetFlags(),this.struct,flags)
                
     if not this.attached
     	  this.attached = true
         	  
        this.docked = not this.docked
        this.setPos()
        this.docked = not this.docked 
       
        if this.className == "TOOLBARCTRL"
        	  if type("this.dockObj") == "O" and;
              not this.dockObj.visible	

              this.dockObj.visible = false
           endif 
        endif 
                         	   
     endif

     return true
  endif

  return false
  



  
 
 function setPos(nLeft,nTop,nWidth,nHeight,nState)
 ******************************************************
 // <nState> : 0 - Horizontal, 1 - Vertical, 2 - Float

  if not this.attached
     return false
  endif
   
  local flags,bDef

  flags = 0
  bDef = true

  if type("argvector(5)") # "N"

     if not this.docked 
        nState = 2 
     elseif this.alignment == 0 or this.alignment == 3
        nState = 0
     elseif this.alignment == 1 or this.alignment == 2
        nState = 1
     endif          
  endif

  if type("argvector(4)") == "N" and;
     type("argvector(3)") == "N"

     flags = bitor(flags,SD_SIZE)
     bDef = false

     if nState <= 1 
        this.dockWidth = nWidth	
        this.dockHeight = nHeight 
     else
        this.floatWidth = nWidth	
        this.floatHeight = nHeight 
     endif	
  else
     store 0 to nWidth,nHeight	
  endif

  if type("argvector(2)") == "N" and;
     type("argvector(1)") == "N"

     flags = bitor(flags,SD_POS)
     bDef = false

     if nState <= 1 
        this.dockTop = nLeft	
        this.dockLeft = nTop 
     else
        this.floatTop = nLeft	
        this.floatLeft = nTop 
     endif
  else
     store 0 to nLeft,nTop	     
  endif

  if bDef

  	  flags = bitor(flags,SD_POS)	
  	  flags = bitor(flags,SD_SIZE)

     if this.docked
        nTop = this.dockTop
        nLeft = this.dockLeft
        nWidth = this.dockWidth
        nHeight = this.dockHeight
     else     
     	  nTop = this.floatTop 
        nLeft = this.floatLeft  
        nWidth = this.floatWidth
        nHeight = this.floatHeight 
     endif

  endif

  if nState == 2 
     flags = bitor(flags,SD_POS_FLOAT)
  elseif nState == 1 
     flags = bitor(flags,SD_POS_VERT)
  elseif nState == 0 
     flags = bitor(flags,SD_POS_HORZ)
  endif

  flags = bitor(flags,SD_DOCK_RECALC)
     
  return dBCWndCtrl::setDockBar(Null,nLeft,nTop,nWidth,nHeight,0,Null,flags)



 function setText(cText)
 ***********************************************

  if type("argvector(1)") == "C"
     this.text = cText	  
  endif

  if type("WINAPI_SetWindowText") # "FP"   
     extern CINT WINAPI_SetWindowText(CHANDLE,CSTRING) user32 from "SetWindowTextA"
  endif	
         
  return WINAPI_SetWindowText(this.hWnd,this.text)



 function getPos
 ***********************************************
  local nLeft,nTop,nWidth,nHeight
	
  if this.struct # Null

     nLeft = this.struct.getByte(4);
      	  + bitLShift(this.struct.getByte(5),8)

     nTop = this.struct.getByte(8);
       	 + bitLShift(this.struct.getByte(9),8)

     nWidth = this.struct.getByte(12);
       		+ bitLShift(this.struct.getByte(13),8)

     nHeight = this.struct.getByte(16);
       		 + bitLShift(this.struct.getByte(17),8)
    
     if this.docked
     	  this.dockTop = nTop	
        this.dockLeft = nLeft
        this.dockWidth = nWidth	
        this.dockHeight = nHeight 
     else
        this.floatTop = nTop
        this.floatLeft = nLeft
        this.floatWidth = nWidth	
        this.floatHeight = nHeight 
     endif

     return true

  endif

  return false
			 

 function getState
 ***********************************************

 if this.struct # Null

  	  this.docked = iif(this.struct.getByte(0) == 1,true,false)

     if this.docked
        this.alignment = this.struct.getByte(1)
     endif

     return true

  endif

  return false


 return


 function getFlags
 ***********************************************
  local flags; flags = 0

  if this.alignment == 0     and this.horizontable  
     flags = bitor(flags,TBR_ALIGN_TOP)
  elseif this.alignment == 1 and this.verticable
     flags = bitor(flags,TBR_ALIGN_LEFT)
  elseif this.alignment == 2 and this.verticable
     flags = bitor(flags,TBR_ALIGN_RIGHT)
  elseif this.alignment == 3 and this.horizontable
     flags = bitor(flags,TBR_ALIGN_BOTTOM)
  endif

  if this.className == "TOOLBARCTRL"

  	  flags = bitor(flags,TBR_TYPE_TOOLWND)

  	  if type("this.dockObj") == "O" and;
     	  not this.dockObj.visible
     	  flags = bitor(flags,TBR_STATE_HIDE)
  	  endif	

  elseif this.className == "TOOLBARAPPCTRL"

  	  if not _app.speedBar	
     	  flags = bitor(flags,TBR_STATE_HIDE)
     endif   	

  elseif not this.visible
     flags = bitor(flags,TBR_STATE_HIDE)
  endif  
  
  if not this.docked and this.floatable
     flags = bitor(flags,TBR_STATE_FLOAT)
  endif

  if this.horizontable
     flags = bitor(flags,TBR_ALLOW_ORIENT_HORZ)
  endif

  if this.verticable
     flags = bitor(flags,TBR_ALLOW_ORIENT_VERT)
  endif

  if this.floatable
     flags = bitor(flags,TBR_ALLOW_FLOATABLE)
  endif

  if this.moveable
     flags = bitor(flags,TBR_ALLOW_MOVEABLE)
  endif

  if this.sizeable
  	  flags = bitor(flags,TBR_ALLOW_SIZEABLE)	
     flags = bitor(flags,TBR_STYLE_SIZEBDR)
  endif
  
  if this.rotatable
     flags = bitor(flags,TBR_STYLE_ROTATABLE)
  endif

  if this.outerEdge
     flags = bitor(flags,TBR_STYLE_OUTEDGE)
  endif

  if this.innerEdge
     flags = bitor(flags,TBR_STYLE_INNEDGE)
  endif

  if this.caption
  	  this.gripper = false	
     flags = bitor(flags,TBR_STYLE_CAPTION)
  endif

  if this.gripper
     flags = bitor(flags,TBR_STYLE_GRIPPER)
  endif

  if this.stretch
     flags = bitor(flags,TBR_STYLE_STRETCH) 
  endif 

  return flags


 function show
 *****************************
 this.dockObj.visible = true
 return
 

 function hide
 *****************************
 this.dockObj.visible = false
 return

 
endclass





class ToolBarAppCtrl of ToolBarCtrl custom
***************************************************
 this.className = "TOOLBARAPPCTRL"

 this.wrapable = true 


 //PROTECT dockObj//,attach,detach



 function getFlags
 ***********************************************
  local flags

  flags = ToolBarCtrl::getFlags()
 
  if this.wrapable
     flags = bitor(flags,TBR_STYLE_WRAPABLE) 
  endif

  return flags


endclass




class StatusBarAppCtrl of dBCWndCtrl custom
***************************************************
 this.className = "STATUSBARAPPCTRL"

 this.progress = Null

 this.frameObj = Null


 function attach
 ***********************************************

  if this.progress # Null
     this.progress.parent = this
     this.progress.attached = true
     this.progress.setRange()
     this.progress.setPos()
  endif

  this.attached = true

 return true


 function detach
 ***********************************************

 if this.progress # Null
    this.progress.attached = false
 endif

 this.attached = false

 return true


 function setText(cText)
 ***********************************************         
 return dBCWndCtrl::setStatusBar(0,0,0,cText,SSB_TEXT)



 function setProgress(nMin,nNax,nPos,fSet)
 ***********************************************
 if this.progress # Null
    return dBCWndCtrl::setStatusBar(nMin,nNax,nPos,Null,fSet)
 endif

 return
    

 function release
 **************************************************

  if this.progress # Null
     this.progress.release()
  endif
    
  dBCWndCtrl::release()

 return


endclass


class ProgressCtrl of dBCWndCtrl custom
***************************************************
 this.className = "PROGRESSCTRL"

 this.visible = false

 this.rangeMin = 0
 this.rangeMax = 100

 this.position = 0

 this.parent = Null


 function show(bShow)
 ******************************************
  local flags

  if not this.attached
     return false
  endif

  flags = bitor(SSB_PROGRESS,iif(bShow,SSB_AUTO,SSB_HIDE))

  this.visible = bShow

 //return dBCWndCtrl::setStatusBar(this.parent.hWnd,0,0,0,Null,flags)
 return this.parent.setProgress(0,0,0,flags)
                            

 
 function setPos(nPos)
 *********************************************** 
  local flags

  if not this.attached
     return false
  endif

  flags = bitor(SSB_PROGRESS,SSB_POS)

  if type("argvector(1)") == "N"        
     this.position = nPos
  endif

 //return dBCWndCtrl::setStatusBar(this.parent.hWnd,0,0,this.position,Null,flags)
 return this.parent.setProgress(0,0,this.position,flags)

 function setRange(nMin,nMax)
 ***********************************************  
 local flags

  if not this.attached
     return false
  endif

  flags = bitor(SSB_PROGRESS,SSB_RANGE)       

  if type("argvector(1)") == "N"         
      this.rangeMin = nMin
  endif

  if type("argvector(2)") == "N"         
      this.rangeMax = nMax
  endif

  //return dBCWndCtrl::setStatusBar(this.parent.hWnd,;
                             this.rangeMin,this.rangeMax,0,Null,flags)
  return this.parent.setProgress(this.rangeMin,this.rangeMax,0,flags)


endclass






class ToolBarDef of ToolBar custom
***************************************************

 this.attached = false

 this.btnsStyle = 0
 this.btnsMixed = false
 this.btnsWidth = 0
 this.btnsPadding = 0  

 this.attachObj = Null
 this.aItems = Null
 this.struct = Null



 function setStruct(iBtn,struct)
 ********************************************
 if argcount() == 2
    return dBCWndCtrl::setToolBar(iBtn,Null,struct,STB_TBUTTON_STRUCT)
 endif

 return false 


 function setState(iBtn,fState)
 ********************************************
  if argcount() == 2
     return dBCWndCtrl::setToolBar(iBtn,fState,Null,STB_TBUTTON_STATE)                                                               
  endif

 return false


 function setText(iBtn,cText,fType)
 ********************************************
 if argcount() == 3
     return dBCWndCtrl::setToolBar(iBtn,Null,cText,fType)                                                                                            
 endif

 return false


 function setMenu(iBtn,hMenu)
 ********************************************
 if argcount() == 2
    return dBCWndCtrl::setToolBar(iBtn,hMenu,Null,STB_TBUTTON_MENU)                                                                                          
 endif

 return false
 
  
 function setMetric
 ********************************************

  //if this.imageWidth > 0 or this.imageHeight > 0
     dBCWndCtrl::setToolBar(this.imageWidth,this.imageHeight,Null,STB_TBAR_BMPSIZE)
  //else
  //	  return false
  //endif

  if this.btnsWidth > 0 or this.btnsPadding > 0
      dBCWndCtrl::setToolBar(this.btnsWidth,this.btnsPadding,Null,STB_TBAR_BTNWIDTH)
  endif

  return true


 function recalc
 ******************************************************
 return dBCWndCtrl::setToolBar(0,0,Null,STB_TBAR_RECALC)

 
 
 function show
 *************************
 this.visible = true
 return
 

 function hide
 *************************
 this.visible = false
 return


 function release
 *********************************************
  local i,obj
      
  this.detach()
        
   for i = 1 to this.aItems.size
       obj = this.aItems[i]

       if not empty(obj)
          obj.release(true)
       endif
   endfor
 
   dBCWndCtrl::release()

 return


endclass




class ToolBoxFx(parentObj) of ToolBarDef custom
***************************************************
 
 this.transparent = true

 this.orientation = 0

 this.width = 0
 this.height = 0

 this.parent = parentObj


 PROTECT floating,getFlags,attachObj,struct



 function attach
 ********************************************

  if this.attached or this.aItems == Null
     return false

  elseif type("this.parent") == "O" and;
  	  this.parent.hWnd == 0

     return false
  endif 
         
  local oForm,bShow,hWndParent

  if type("this.parent.form") == "O"
     oForm = this.parent.form
     hWndParent = this.parent.hWnd
  else
  	  oForm = this.parent
     hWndParent = this.parent.hWndClient
  endif  

  if oForm.baseClassName == "FORM"  
     this.attachObj = iif(oForm.mdi,_app.frameWin,oForm)
  else
     this.attachObj = oForm
  endif 

  bShow = this.visible
                           
  ToolBar::attach(this.attachObj) 

  this.visible = false
           
  if dBCWndCtrl::setToolBar(hWndParent,oForm.hWnd,Null,STB_TBAR_PARENT)

     this.attached = true

     this.setMetric()
	  
     local oItem,i,idGroup
     idGroup = 0

     for i = 1 to this.aItems.size         
          oItem = this.aItems[i]
       
          if not empty(oItem) and not oItem.separator 
                     
             if oItem.group
                if idGroup == 0
                   idGroup = oItem.id
                endif 
                oItem.idGroup = idGroup

             elseif idGroup > 0
                idGroup = 0
             endif 

             if oItem.setStruct()
                oItem.setStyle()
                oItem.setState()
                oItem.setText()
                oItem.setTextTip()
                oItem.setTextStatus()                
             endif
          endif            
     endfor

     this.setStyle()
     this.setPos()

     this.recalc()	

     this.visible = bShow 

     return true
  endif

 return false


 function detach
 ********************************************

  if this.attachObj # Null    

     ToolBar::detach(this.attachObj)

     this.attachObj = Null
      
     return dBCWndCtrl::setToolBar(0,0,Null,STB_TBAR_PARENT)

  endif

 return false


 function getSize
 ************************************************
 if type("WINAPI_GetClientRect") # "FP"
    extern CLOGICAL WINAPI_GetClientRect(CHANDLE,CPTR) user32 from "GetClientRect"
 endif

 local c
 c = space(8)

 if WINAPI_GetClientRect(this.hWnd,c)

    this.width = c.getByte(8);
               + bitLShift(c.getByte(9),8);
               + bitLShift(c.getByte(10),16);
               + bitLShift(c.getByte(11),24)

    this.height= c.getByte(12);
               + bitLShift(c.getByte(13),8);
               + bitLShift(c.getByte(14),16);
               + bitLShift(c.getByte(15),24)

    return true

 endif

 return false


 function setPos(nLeft,nTop)
 ******************************************************
 
  if type("argvector(1)") == "N" and;
     type("argvector(2)") == "N"

     this.left = nLeft
     this.top  = nTop
  else
  	  nLeft = this.left
     nTop  = this.top    
  endif

 return dBCWndCtrl::setToolBar(nLeft,nTop,Null,STB_TBAR_POS)



 function setStyle(iBtn,fStyle)
 ********************************************
  if argcount() == 2
  	  return dBCWndCtrl::setToolBar(iBtn,fStyle,Null,STB_TBUTTON_STYLE)
  endif

  local fStyle,fExStyle
  
  fStyle = TBSTYLE_WRAPABLE
  //fStyle = bitor(fStyle,TBSTYLE_TOOLTIPS)

  if this.flat
  	  fStyle = bitor(fStyle,TBSTYLE_FLAT)
  endif

  if this.transparent
     fStyle = bitor(fStyle,TBSTYLE_TRANSPARENT)
  endif

  if this.orientation == 1
     fStyle = bitor(fStyle,TBSTYLE_VERTICAL)
  endif
 
  if this.btnsStyle > 0
     fStyle = bitor(fStyle,TBSTYLE_SHOWTEXT)
  endif

  if this.btnsStyle == 2
     fStyle = bitor(fStyle,TBSTYLE_LIST)
  endif

  fExStyle = TBSTYLE_EX_DRAWDDARROWS

  if this.btnsMixed
  	  fExStyle = bitor(fExStyle,TBSTYLE_EX_MIXEDBUTTONS)
  endif

  return dBCWndCtrl::setToolBar(fStyle,fExStyle,Null,STB_TBAR_STYLE)


endclass



class ToolBarFx of ToolBarDef custom
***************************************************
 
 this.docked = true

 this.stretch = false

 this.gripper = true
 this.caption = false
 this.outerEdge = true
 this.innerEdge = false

 this.moveable = true
 this.sizeable = true
 this.wrapable = true
 this.rotatable = true
 this.floatable = true
 this.adjustable = false
 this.verticable = true
 this.horizontable = true

 this.alignment = 0

 this.dockTop = 0
 this.dockLeft = 0
 this.dockWidth = 0
 this.dockHeight = 0

 this.floatTop = 0
 this.floatLeft = 0
 this.floatWidth = 0
 this.floatHeight = 0
 
 this.frameObj = Null


 PROTECT floating,left,top,getFlags,attachObj,struct


 function attach(frameObj)
 ********************************************

  if this.attached or this.aItems == Null
     return false

  elseif type("argvector(1)") # "O" or frameObj.hWnd == 0
     return false
  endif   
 
  if frameObj.baseClassName == "FORM"  
     this.attachObj = iif(frameObj.mdi,_app.frameWin,frameObj)

  elseif frameObj.baseClassName == "SUBFORM" or; 
  			frameObj.baseClassName == "FRAMEWINDOW" 			 
     this.attachObj = frameObj

  elseif frameObj.baseClassName == "CONTAINER"    
     this.attachObj = _app.frameWin  

  else
      return false
  endif 

  local bShow

  bShow = this.visible
                           
  ToolBar::attach(this.attachObj) 

  this.visible = false
  this.frameObj = frameObj 
           
  if ToolBarCtrl::setDock()

     local oItem,i,idGroup
     idGroup = 0

     for i = 1 to this.aItems.size         
          oItem = this.aItems[i]
       
          if not empty(oItem) and not oItem.separator 
                     
             if oItem.group
                if idGroup == 0
                   idGroup = oItem.id
                endif 
                oItem.idGroup = idGroup

             elseif idGroup > 0
                idGroup = 0
             endif 

             if oItem.setStruct()
                oItem.setStyle()
                oItem.setState()
                oItem.setText()
                oItem.setTextTip()
                oItem.setTextStatus()                
             endif
          endif            
     endfor

     this.setMetric()
	  this.setStyle()	

     this.recalc()

     this.visible = bShow 

     return true
  endif

 return false



 function detach
 ********************************************

  if this.attachObj # Null    

     ToolBar::detach(this.attachObj)

     this.attachObj = Null
      
     return ToolBarCtrl::detach()

  endif

 return false


 function getPos
 ***********************************************
 return ToolBarCtrl::getPos()


 function getState
 ***********************************************
 return ToolBarCtrl::getState()


 function getFlags
 ***********************************************
  local flags

  flags = ToolBarCtrl::getFlags()

  flags = bitor(flags,TBR_TYPE_TOOLBAR)
 
  if this.wrapable
     flags = bitor(flags,TBR_STYLE_WRAPABLE) 
  endif

  if this.adjustable
     flags = bitor(flags,TBR_STYLE_ADJUSTABLE) 
  endif

  return flags



  function setPos(nLeft,nTop,nWidth,nHeight,nSet,nState)
 ******************************************************
 return ToolBarCtrl::setPos(nLeft,nTop,nWidth,nHeight,nSet,nState)



 function setDock(frameObj)
 ********************************************
 return ToolBarCtrl::setDock(frameObj)	



 function setStyle(iBtn,fStyle)
 ********************************************
  if argcount() == 2
  	  return dBCWndCtrl::setToolBar(iBtn,fStyle,Null,STB_TBUTTON_STYLE)
  endif

  local fStyle,fExStyle

  fStyle = TBSTYLE_WRAPABLE
  fStyle = bitor(fStyle,TBSTYLE_TOOLTIPS)
  //fStyle = bitor(fStyle,TBSTYLE_TRANSPARENT)
  
  if this.flat
  	  fStyle = bitor(fStyle,TBSTYLE_FLAT)
  endif
 
  if this.btnsStyle > 0
     fStyle = bitor(fStyle,TBSTYLE_SHOWTEXT)
  endif

  if this.btnsStyle == 2
     fStyle = bitor(fStyle,TBSTYLE_LIST)
  endif

  fExStyle = TBSTYLE_EX_DRAWDDARROWS

  if this.btnsMixed
  	  fExStyle = bitor(fExStyle,TBSTYLE_EX_MIXEDBUTTONS)
  endif

  return dBCWndCtrl::setToolBar(fStyle,fExStyle,Null,STB_TBAR_STYLE)



endclass


class ToolButtonFx(oParent) of Toolbutton(oParent) custom
************************************************************ 
 
 this.group = false 
 this.toggle = false
 this.grayed = false
 this.autoSize = false

 this.dropDown = false
 this.dropStyle = 0 // 0 - default, 1 - whole drop-down style
 
 this.text = ""
 this.textTip = ""
 this.textStatus = ""
 
 this.hMenu = 0
 this.idSelMenu = 1

 this.id = -1
 this.idGroup = 0 
 
 this.aItems = Null
 this.struct = Null

 if this.parent.aItems == Null
    this.parent.aItems = (new array())
 endif

 this.id = this.parent.aItems.size + 1

 this.parent.aItems.add((this))    
	  
 
 PROTECT twoState,speedTip,struct


 
 function setStruct
 ********************************************
 if this.struct == Null
    this.struct = space(10)
             
    //return dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                       Null,this.struct,STB_TBUTTON_STRUCT)
    return this.parent.setStruct(this.id -1,this.struct)

 endif

 return false 
 

 function setStyle
 ********************************************
  local flags

  if not this.separator
     
     flags = TBSTYLE_BUTTON
       
     if this.toggle       
         flags = bitor(flags,TBSTYLE_CHECK)
      
     elseif this.group 
         flags = bitor(flags,bitor(TBSTYLE_CHECK,TBSTYLE_GROUP))
     endif 
 
     if this.autoSize
        flags = bitor(flags,TBSTYLE_AUTOSIZE)
     endif

     if this.dropDown
        flags = bitor(flags,iif(this.dropStyle == 1,;
                       TBSTYLE_WHOLEDROPDOWN,TBSTYLE_DROPDOWN))
        this.setMenu()
     endif

     if this.parent.btnsStyle > 0
        flags = bitor(flags,TBSTYLE_SHOWTEXT)
     endif
                                    
     //return dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                               flags,Null,STB_TBUTTON_STYLE)
     return this.parent.setStyle(this.id -1,flags)

  endif
       
 return false


 function setState
 ********************************************
  local flags

  if not this.separator
     
     flags = 0

     if this.enabled
        flags = bitor(flags,TBSTATE_ENABLED)
     endif

     if not this.visible
        flags = bitor(flags,TBSTATE_HIDDEN)
     endif

     if this.checked and (this.toggle or this.group)
        flags = bitor(flags,TBSTATE_CHECKED)
     endif

     if this.grayed
        flags = bitor(flags,TBSTATE_INDETERMINATE)
     endif

     //return dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                               flags,Null,STB_TBUTTON_STATE)
     return this.parent.setState(this.id -1,flags)
                                                                
  endif

 return false

 
 function setCheck(bCheck)
 ********************************************

  if argcount() == 1
     this.checked = bCheck
  else  
     this.checked = not this.checked
  endif

  local flags,bResult

  if this.toggle
    
     //bResult = dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
     		 	   	    bitor(TBSTATE_CHECKED,iif(this.checked,;
                      TBFLAGS_ADD,TBFLAGS_REM)),Null,STB_TBUTTON_STATE)

      flags = bitor(TBSTATE_CHECKED,iif(this.checked,TBFLAGS_ADD,TBFLAGS_REM))

      bResult = this.parent.setState(this.id -1,flags)
   
   elseif this.group

     local i

     for i = this.idGroup to this.parent.aItems.size  
         if this.parent.aItems[i].idGroup == this.idGroup  
            this.parent.aItems[i].checked = this.id == i    
         endif           
     endfor  

     //bResult = dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                      bitor(TBSTATE_CHECKED,TBFLAGS_ADD),;
                      Null,STB_TBUTTON_STATE)    

      flags = bitor(TBSTATE_CHECKED,TBFLAGS_ADD)

      bResult = this.parent.setState(this.id -1,flags)

   endif

   //if bResult and this.checked and this.onClick # Null
   //	this.onClick()
   //endif

  return iif(bResult,this.checked,false)

  

 function setText(cText)
 *****************************************************************
  if argcount() == 1
     this.text = cText
  endif

  if this.parent.btnsStyle > 0    

     //return dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                              Null,this.text,STB_TBUTTON_TEXT)

     return this.parent.setText(this.id -1,this.text,STB_TBUTTON_TEXT)

  endif

 return false


 function setTextTip(cText)
 *****************************************************************
  if argcount() == 1
     this.textTip = cText

  elseif this.textTip == ""
     return false
  endif
     
  //return dBCWndCtrl::setToolBar(this.parent.hWnd,this.id -1,;
                           Null,this.textTip,STB_TBUTTON_TEXT_TIP)
  return this.parent.setText(this.id -1,this.textTip,STB_TBUTTON_TEXT_TIP)
  

  
 function setTextStatus(cText)
 *****************************************************************
  if argcount() == 1
     this.textStatus = cText

  elseif this.textStatus == ""
     return false
  endif
     
  //return dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                           Null,this.textStatus,STB_TBUTTON_TEXT_STATUS)
  return this.parent.setText(this.id -1,this.textStatus,STB_TBUTTON_TEXT_STATUS)
  
  

  
 function setMenu(hMenu)
 *****************************************************************

 if argcount() == 1
    this.hMenu = hMenu

 elseif this.aItems # Null

     MenuFx::createMenu()
             
     local i,obj 
     idGroup = 0  

     for i = 1 to this.aItems.size
        obj = this.aItems[i]

        if not empty(obj) and obj.parent == (this)
            obj.create(true)
        endif
     endfor
     
 elseif this.hMenu == 0
    return false
 endif

 //return dBCWndCtrl::setToolBar(this.parent.hwnd,this.id -1,;
                          this.hMenu,Null,STB_TBUTTON_MENU)
 return this.parent.setMenu(this.id -1,this.hMenu)


 function getChecked
 ********************************************
  if this.toggle
     return this.checked

  elseif this.group

  	  local i
    
     for i = this.idGroup to this.parent.aItems.size  
         if this.parent.aItems[i].idGroup == this.idGroup and;  
            this.parent.aItems[i].checked

            return this.parent.aItems[i].id
         endif           
     endfor

     return 0

  endif

 return false

 

 function getSelMenu
 *********************************************
  if this.aItems # Null and this.hMenu > 0

  	  local i,obj

     i = this.struct.getByte(1)

     if i > 0 and i <= this.aItems.size
        this.struct.setByte(1,0)
     	  this.idSelMenu = i
     else   	
     	  i = this.idSelMenu
     endif
     
     obj = this.aItems[i]
        	
     if this.struct.getByte(0) == 0                      
        if obj.group or obj.toggle
           obj.setCheck()
        endif
     endif

     if obj.onClick # Null
        obj.onClick()
     endif         
    
     return i

  endif

  return 0

  
 function release(bProc)
 **************************************************
  local i,obj

  if this.aItems # Null

      if this.hMenu > 0
         MenuFx::destroyMenu()

        this.hMenu = 0 
      endif    
 
     for i = 1 to this.aItems.size
         obj = this.aItems[i]
         release object obj
         this.aItems[i] = Null
         obj = Null
     endfor

     obj = this.aItems
     release object obj
     this.aItems = Null
     obj = Null
  endif

  if bProc

     release object this

  endif

 return


endclass





class MenuFx(oParent,cName)
********************************************
 this.className = "MENUFX"

 this.enabled = true
 this.checked = false 

 this.group = false
 this.toggle = false
 this.separator = false
 this.menuBreak = false

 this.id = -1

 this.parent = oParent

 this.name = cName
 
 this.text = ""
 this.shortCut = ""
 this.textStatus = ""

 this.idGroup = 0 // auto setting; this id first element in group

 this.aItems = Null

 this.subMenu = false // auto setting

 this.hMenu = 0 // auto setting if subMenu

 this.onClick = Null


 if not type("this.parent") == "O"
    this.parent = Null

 else
 	 if this.parent.className == "MENUFX"
       this.parent.subMenu = true  
        
    elseif this.parent.aItems == Null
       this.parent.aItems = (new array())
         
    endif  

    this.aItems = this.parent.aItems
    this.aItems.add((this))

    this.id = this.aItems.size

    if not type("this.name") == "C"
       this.name = this.className + this.id
    endif

 endif


 
 function createMenu
 **************************************************
  if type("WINAPI_CreatePopupMenu") # "FP"
     extern CHANDLE  WINAPI_CreatePopupMenu(CVOID) user32 from "CreatePopupMenu"
  endif

  this.hMenu = WINAPI_CreatePopupMenu()

  return 


  function destroyMenu
 **************************************
  if type("WINAPI_DestroyMenu") # "FP"
     extern CLOGICAL WINAPI_DestroyMenu(CHANDLE) user32 from "DestroyMenu" 
  endif  

  return WINAPI_DestroyMenu(this.hMenu)



 function create(bProc)
 **************************************************
  local i,flags,textComp

  if not bProc
     idGroup = 0
  endif
 
  flags = MF_BYCOMMAND

  if this.separator
     flags = bitor(flags,MF_SEPARATOR)
     textComp = ""
  else
     flags = bitor(flags,MF_STRING)

     if not this.text == ""
        textComp = this.text
     else
        textComp = this.name
     endif
                 
     if not this.shortCut == ""
        textComp += chr(9) + this.shortCut
     endif

     if not this.subMenu       
        if this.group
           if this.idGroup == 0
              this.idGroup = iif(idGroup > 0,idGroup,this.id)
           endif

           flags = bitor(flags,MF_RADIOCHECK)
        endif 

        if this.checked and (this.group or this.toggle)
           flags = bitor(flags,MF_CHECKED)
        endif 
     endif 

     if not this.enabled
        flags = bitor(flags,MF_GRAYED)
     endif      

     if this.menuBreak
        flags = bitor(flags,MF_MENUBARBREAK)
     endif
         
  endif


  if type("WINAPI_IsMenu") # "FP"
     extern CLOGICAL WINAPI_IsMenu(CHANDLE) user32 from "IsMenu"
  endif

  if type("WINAPI_AppendMenu") # "FP"
     extern CLOGICAL WINAPI_AppendMenu(CHANDLE,CUINT,CUINT,CSTRING) user32 from "AppendMenuA"
  endif

  if type("WINAPI_InsertMenu") # "FP"
     extern CLOGICAL WINAPI_InsertMenu(CHANDLE,CUINT,CUINT,CUINT,CSTRING) user32 from "InsertMenuA"
  endif


  if bProc
     WINAPI_AppendMenu(this.parent.hMenu,flags,this.id,textComp)

  else
     i = this.next().id
     WINAPI_InsertMenu(this.parent.hMenu,;
                iif(this.id >= i,-1,i),flags,this.id,textComp)
  endif

  if not this.textStatus == ""
     this.setTextStatus()
  endif

  if this.hMenu > 0 and WINAPI_IsMenu(this.hMenu)
     this.setSubMenu()

  elseif this.subMenu
     this.createMenu()     
     this.setSubMenu()

     local obj
    
     for i = this.id + 1 to this.aItems.size
         obj = this.aItems[i]

         if not empty(obj) and obj.parent == (this)
            obj.create(true)
         endif
     endfor
  endif

  idGroup = this.idGroup
 
 return


 function destroy
 **************************************

  if this.hMenu > 0
     this.destroyMenu()
     this.hMenu = 0
  endif 

  if type("WINAPI_DeleteMenu") # "FP"
     extern CLOGICAL WINAPI_DeleteMenu(CHANDLE,CUINT,CUINT) user32 from "DeleteMenu"
  endif

 return WINAPI_DeleteMenu(this.parent.hMenu,this.id,MF_BYCOMMAND)      
   

 
 function reindex
 **************************************
 local i,idGroup,obj

 idGroup = 0

 if this.aItems # Null
    for i = 1 to this.aItems.size
        obj = this.aItems[i]
        obj.id = i
        obj.idGroup = 0
       
        if not obj.subMenu       
           if obj.group
              if idGroup == 0
                 idGroup = obj.id
              endif             
              obj.idGroup = idGroup               

           elseif idGroup > 0
              idGroup = 0
           endif 
        endif       
    endfor
  endif

 return
  

 function next
 **************************************************
  local i,count,obj

  count = this.aItems.size

  if count > 1
     i = iif(this.id < count,this.id + 1,1)
     do
        obj = this.aItems[i ++]
        if obj.parent == this.parent
           exit
        endif
        if i > count
           i = 1
        endif
     until false  

     return obj
  endif
  
  return (this)

  
 
 function setType
 *****************************************************************
  local flags

  if this.separator
     flags = MF_SEPARATOR       
  else
     flags = MF_STRING
  endif

  if this.hMenu > 0  
     this.setSubMenu()

     flags = bitor(flags,MF_POPUP)
  endif

  if this.group and not this.subMenu 
     flags = bitor(flags,MF_RADIOCHECK)
  endif  

  if this.menuBreak
     flags = bitor(flags,MF_MENUBARBREAK)
  endif   

  return dBCWndCtrl::setToolMenu(this.parent.hMenu,this.id,;
                            flags,Null,STM_MENUITEM_TYPE)
  

 function setState
 *****************************************************************
  local flags

  flags = 0                                          

  if not this.enabled
     flags = bitor(flags,MF_GRAYED)
  endif

  if this.checked and (this.toggle or this.group)
     flags = bitor(flags,MF_CHECKED)
  endif


  return dBCWndCtrl::setToolMenu(this.parent.hMenu,this.id,;
                            flags,Null,STM_MENUITEM_STATE)


  
 function setCheck(bCheck)
 *****************************************************************

  if this.toggle
 	
     bCheck = iif(argcount() == 0,not this.checked,bCheck)

     this.checked = bCheck
    
     if type("WINAPI_CheckMenuItem") # "FP"
        extern CLONG WINAPI_CheckMenuItem(CHANDLE,CUINT,CUINT) user32 from "CheckMenuItem"
 	  endif
           
     return WINAPI_CheckMenuItem(this.parent.hMenu,this.id,;
                                 iif(bCheck,MF_CHECKED,0)) # -1

  elseif this.group

     local idLast
    
     for i = this.idGroup to this.parent.aItems.size   
         if this.parent.aItems[i].idGroup == this.idGroup   
            this.parent.aItems[i].checked = (this.id == i)
            idLast = this.parent.aItems[i].id                      
         endif     
     endfor

     if type("WINAPI_CheckMenuRadioItem") # "FP"    
        extern CLOGICAL WINAPI_CheckMenuRadioItem(CHANDLE,CUINT,CUINT,CUINT,CUINT) user32 from "CheckMenuRadioItem"
 	  endif
   
     return WINAPI_CheckMenuRadioItem(this.parent.hMenu,;
                                      this.idGroup,idLast,this.id,0)
  endif

  return false



 function setSubMenu(hMenu)
 *****************************************************************

  if argcount() == 1  
     this.hMenu = iif(WINAPI_IsMenu(hMenu),hMenu,0)   
              
  elseif this.hMenu == 0
     return false

  endif

  return dBCWndCtrl::setToolMenu(this.parent.hMenu,this.id,;
                             this.hMenu,Null,STM_MENUITEM_SUB)


 function setText(cText)
 *****************************************************************

  if argcount() == 1
     this.text = cText
  endif

  textComp = this.text 

  if not this.shortCut == ""
     textComp += chr(9) + this.shortCut
  endif
             
 return dBCWndCtrl::setToolMenu(this.parent.hMenu,this.id,;
                           Null,textComp,STM_MENUITEM_TEXT)



 function setShortCut(cShortCut)
 *****************************************************************

  if argcount() == 1
     this.shortCut = cShortCut
  endif

  textComp = this.text 

  if not this.shortCut == ""
     textComp += chr(9) + this.shortCut
  endif
             
 return dBCWndCtrl::setToolMenu(this.parent.hMenu,this.id,;
                           Null,textComp,STM_MENUITEM_TEXT)


 function setTextStatus(cText)
 *****************************************************************

  if argcount() == 1
     this.textStatus = cText

  elseif this.textStatus == ""
     return false

  endif
     
  return dBCWndCtrl::setToolMenu(this.parent.hMenu,this.id,;
                            Null,this.textStatus,STM_MENUITEM_TEXT_STATUS)



 function release(bProc)
 **************************************************
  local i,obj
  
  if this.subMenu
     for i = this.aItems.size to 1 step -1
         obj = this.aItems[i]

         if not empty(obj) and obj.parent == (this)
            obj.release(true)
         endif
     endfor
   endif

   this.aItems.delete(this.id)
   this.aItems.resize(this.aItems.size -1)

   if not bProc
      this.reindex() 
   endif
   
   release object this

 return


 
endclass






class FormFx of Form custom
******************************************************

 this.attached = false

 this.thickFrame = true

 this.dockBarEdge = true
 this.dockBarExpand = true
 this.dockBarHiding = false

 this.scrollBackground = true
  
 this.widthMin = 0
 this.widthMax = 0 

 this.heightMin = 0 
 this.heightMax = 0

 this.hScrollBar = Null
 this.vScrollBar = Null


 PROTECT scrollBar,scrollHOffset,scrollVOffset,getFlags


 function attach
 *********************************************** 
 return FrameCtrl::attach()


 function detach
 ***********************************************
 return FrameCtrl::detach()


 function recalc
 ***********************************************
 return FrameCtrl::recalc()


 function scroll(nHorz,nVert)
 ***********************************************  
 return FrameCtrl::scroll(nHorz,nVert)

   
 function setRange(nWhMin,nHtMin,nWhMax,nHtMax)
 ***********************************************
 return FrameCtrl::setRange(nWhMin,nHtMin,nWhMax,nHtMax)


 function getFlags
 ***********************************************
 return FrameCtrl::getFlags()


 function release
 **************************************************   
  FrameCtrl::release()

  super::release()
  
 return

 
endclass 



class SubFormFx(formObj) of SubForm(formObj) custom
******************************************************

 this.attached = false

 this.thickFrame = true

 this.dockBarEdge = true
 this.dockBarExpand = false
 this.dockBarHiding = false

 this.scrollBackground = true
  
 this.widthMin = 0
 this.widthMax = 0 

 this.heightMin = 0 
 this.heightMax = 0

 this.hScrollBar = Null
 this.vScrollBar = Null


 PROTECT scrollBar,scrollHOffset,scrollVOffset,getFlags


 function attach
 *********************************************** 
 return FrameCtrl::attach()


 function detach
 ***********************************************
 return FrameCtrl::detach()


 function recalc
 ***********************************************
 return FrameCtrl::recalc()


 function scroll(nHorz,nVert)
 ***********************************************   
 return FrameCtrl::scroll(nHorz,nVert)

   
 function setRange
 ***********************************************
 return FrameCtrl::setRange()


 function getFlags
 ***********************************************
 return FrameCtrl::getFlags()


 function release
 **************************************************   
  FrameCtrl::release()

  super::release()
  
 return

 
endclass 




class ContainerFx(parent) of Container(parent) custom
******************************************************

 this.attached = false

 this.dockBarEdge = true

 this.widthMin = 0
 this.widthMax = 0 

 this.heightMin = 0 
 this.heightMax = 0

 this.curPage = 1

 this.client = Null
 this.hWndClient = 0

 this.controls = Null

 this.onPage = Null

 this.hScrollBar = Null
 this.vScrollBar = Null


 if type("WINAPI_ShowWindow") # "FP" 
    extern CLOGICAL WINAPI_ShowWindow(CHANDLE,CINT) user32 from "ShowWindow"
 endif

 if type("WINAPI_SetWindowLong") # "FP"
    extern CINT WINAPI_SetWindowLong(CHANDLE,CINT,CLONG) user32 from "SetWindowLongA"
 endif


 PROTECT mousePointer,transparent,widthMax,heightMax

 
 function attach
 *******************************************************  

  if this.attached
     return false
  endif

  this.mousePointer = 1

  if this.client # Null

     WINAPI_SetWindowLong(this.client.hWnd,GWL_ID,ID_CLIENT)
   
     if this.hScrollBar # Null
        this.hScrollBar.release()
        this.hScrollBar = Null
     endif

     if this.vScrollBar # Null
        this.vScrollBar.release()
        this.vScrollBar = Null
     endif
  endif

  if FrameCtrl::attach()

     return this.setPage()

  endif

  return false



 function detach
 ***********************************************
 return FrameCtrl::detach()


 function recalc
 ***********************************************
 return FrameCtrl::recalc()


 function scroll(nHorz,nVert)
 ***********************************************  
 return FrameCtrl::scroll(nHorz,nVert)


 function setRange(nWhMin,nHtMin)
 ***********************************************
 return FrameCtrl::setRange(nWhMin,nHtMin)

            



  function setPage(nPage)
 ****************************************
  local obj,bFocus

  if type("argvector(1)") # "N"
     nPage = this.curPage
  endif

  bFocus = false     
  obj = this.first
 
  do
     if obj == this.form.activeControl
        bFocus = true
     endif

     if obj.pageno > 0 and obj.visible
        if obj.pageno == nPage       
           WINAPI_ShowWindow(obj.hWnd,SW_SHOW)      
        else
           WINAPI_ShowWindow(obj.hWnd,SW_HIDE)
        endif
     endif

     obj := obj.before

  until obj == this.first 

  if bFocus
     this.first.setfocus()
  endif
 
  this.curPage = nPage 

  if this.onPage # Null
     this.onPage()
  endif

 return true

 
 function getFlags
 ***********************************************
  local flags 

  flags = CW_TYPE_CON

  if this.dockBarEdge
     flags = bitor(flags,DBR_STYLE_OUTEDGE)
  endif

  return flags


  
 function release
 ************************************************** 
  if this.client # Null
     this.client.release()
  endif

  FrameCtrl::release()
    
  super::release()
  
 return


endclass




class TreeViewFx(parent) of TreeView(parent) custom
***************************************************
set proc to csSrcFx.cc additive

this.iImage = 0
this.iSelectedImage = 1

this.attached = false


   function onOpen
   **********************************
   this.attach()
   this.reloadImages()
   
   return


   
   function attach
   **********************************
   if this.attached
      return false
   endif

   this.attached = dBCWndCtrl::attachClass(CL_TYPE_TREEVIEW)
    
   return this.attached


   function detach
   **********************************
   if not this.attached
      return false
   endif

   this.attached = dBCWndCtrl::detachClass(this.hWnd)
      
   return not this.attached


   function addImage(cSource)
   **********************************
   local hImage
   hImage = ImageSourceCtrl::getHandle(cSource,this.imageSize)

   if hImage == 0
   	return false
   endif

   return dBCWndCtrl::setTreeView(this.hWnd,0,hImage,0,STV_IMAGELIST_ADD)


   function setImageSize(nSize)
   **********************************
   if this.imageScaleToFont = false and argcount() == 1
      this.imageSize = nSize
   else
      nSize = 0
   endif

   dBCWndCtrl::setTreeView(this.hWnd,nSize,0,0,STV_IMAGELIST_CREATE)

   this.reloadImages()

   return
 

   function reloadImages
   **********************************
   local hImg1,hImg2
   
   if not empty(this.image) or ;
      not empty(this.selectedImage)

      hImg1 = ImageSourceCtrl::getHandle(this.image,this.imageSize)
      hImg2 = ImageSourceCtrl::getHandle(this.selectedImage,this.imageSize)

      if hImg1 # 0 or hImg2 # 0

      	dBCWndCtrl::setTreeView(this.hWnd,0,hImg1,hImg2,STV_TREEITEM_IMAGE_NORMAL)

      endif

   endif

   if not empty(this.checkedImage) or ;
      not empty(this.uncheckedImage)

      hImg1 = ImageSourceCtrl::getHandle(this.checkedImage,this.imageSize)
      hImg2 = ImageSourceCtrl::getHandle(this.uncheckedImage,this.imageSize)

      if hImg1 # 0 or hImg2 # 0

      	dBCWndCtrl::setTreeView(this.hWnd,0,hImg1,hImg2,STV_TREEITEM_IMAGE_STATE)

      endif

   endif


   local obj
   obj = this.firstChild

   do while not empty(obj)

     if obj.className == "TREEITEMFX"  
        
     else
        obj.treeObj = this

        obj.iImage = 0
        obj.iSelectedImage = 1
        obj.reloadImages = TreeItemFx::reloadImages
     endif
   
     obj.reloadImages()    
      
     if obj.noOfChildren > 0
        obj = obj.firstChild       

     else
        do while empty(obj.nextSibling) and obj.level # 1                        
           obj = obj.parent         
        enddo

        obj = obj.nextSibling

     endif

   enddo

   return


endclass


class TreeItemFx(parent) of TreeItem(parent) custom
***************************************************
this.iImage = 0
this.iSelectedImage = 1

this.treeObj = Null


if this.parent.baseClassName == "TREEVIEW"
   this.treeObj = parent
else
   this.treeObj = parent.treeObj
endif 
   

   function reloadImages
   **********************************  
   
   if not empty(this.image) or ;
      not empty(this.selectedImage)

      local il,hImg1,hImg2,nSize

      nSize = this.treeObj.imageSize
      hImg1 = ImageSourceCtrl::getHandle(this.image,nSize)
      hImg2 = ImageSourceCtrl::getHandle(this.selectedImage,nSize)

      if hImg1 # 0 or hImg2 # 0

         il = dBCWndCtrl::setTreeView(this.treeObj.hWnd,this.handle,;
                                      hImg1,hImg2,STV_TREEITEM_IMAGE_NORMAL)
      
         this.iImage = int(LOWORD(il))
         this.iSelectedImage = int(HIWORD(il))

      endif

   else

      dBCWndCtrl::setTreeView(this.treeObj.hWnd,this.handle,;
                              this.iImage,this.iSelectedImage,;
                          		bitor(STV_TREEITEM_IMAGE_NORMAL,;
                                		STV_TREEITEM_IMAGE_INDEX))
   endif

   return


endclass




class NoteBookFx(parent) of NoteBook(parent) Custom
******************************************************************** 
set proc to csSrcFx.cc additive

this.attached = false

this.imageSize = 16

this.images = (new AssocArray())



	function onOpen
   **********************************
   this.attach()
  
   return


   function attach
   **********************************
   if this.attached
      return false
   endif

   this.attached = dBCWndCtrl::attachClass(CL_TYPE_NOTEBOOK)


   if this.attached and ;
   	not empty(this.dataSource) and ;
      this.images.count() > 0

   	local i,aTabs,cName,nIndex,hImage
      
      cArray = ltrim(stuff(ltrim(this.dataSource),1,5,""))
      aTabs = &cArray.
      cName = this.images.firstKey
        
      if dBCWndCtrl::setNoteBook(this.imageSize,0,SNB_IMAGELIST_CREATE)
    
         for i = 1 to this.images.count()
     
             nIndex = iif(isAlpha(cName),aTabs.scan(cName),val(cName))

             if nIndex > 0 and nIndex <= aTabs.size

                hImage = ImageSourceCtrl::getHandle(this.images[cName],;
                                                    this.imageSize)          
                if hImage # 0
               
                   dBCWndCtrl::setNoteBook(nIndex -1,hImage,STV_TABITEM_IMAGE)
        
                endif
         
             endif
      
             cName = this.images.nextKey(cName) 

         endfor

      endif

   endif
    
   return this.attached


   function detach
   **********************************
   if not this.attached
      return false
   endif

   this.attached = dBCWndCtrl::detachClass(this.hWnd)
      
   return not this.attached


  
  function release
  ***********************************    
  this.detach()
  
  local obj
  obj = this.images
  obj.removeAll()
  release object obj

  this.images = Null

  NoteBook::release()

  return


 endclass


  
 
class dBGridFx(parent) of dBGrid(parent) custom
******************************************************

 this.attached = false

 this.dockBarEdge = true

 this.widthMin = 0
 this.widthMax = 0 

 this.heightMin = 0 
 this.heightMax = 0

 this.hScrollBar = Null
 this.vScrollBar = Null

 this.hWndClient = 0


 PROTECT mousePointer,transparent,widthMax,heightMax

 
 function attach
 ***********************************************
  if this.attached
     return false
  endif

  this.init()

  return FrameCtrl::attach()


 function detach
 ***********************************************
 return FrameCtrl::detach()


 function recalc
 ***********************************************
 return FrameCtrl::recalc()
         
 
 function getFlags
 ***********************************************
  local flags 

  flags = CW_TYPE_CON

  if this.dockBarEdge
     flags = bitor(flags,DBR_STYLE_OUTEDGE)
  endif

  return flags


 function setRange(nWhMin,nHtMin)
 ***********************************************
 return FrameCtrl::setRange(nWhMin,nHtMin)


 
 function release
 ************************************************** 
  if this.attached
     this.detach()
  endif

  dBGrid::release()

 return


endclass
