/*
    --------------------------------------------------------------
    Programmer..: Romain Strieff
    Program.....: IsExeOpen
    Date........: June 18, 1999
    Notes.......: This routine checks to see if an executable
                  is running -- the executable does not have
                  to be visual, and this does not use the
                  Windows API to do it.
    Written for.: Visual dBASE 7.01
    Rev. History: Jan. 25, 1999 -- first release
                  June 18, 1999 -- fixes based on newsgroup ...
    Calls.......: None
    Usage.......: IsExeOpen( <cFileName> )
    Example.....: ? IsExeOpen( "wordpad.exe" )
    Returns.....: logical (true, if the file is in use/open
                           false if not open)
    Parameters..: cFileName= name of executable (include
                             path and extension)
    --------------------------------------------------------------
*/
function IsExeOpen( cFileName )
   local lReturn
   lreturn = false
   try
      // attempt to open the file, and close it again
      // in the same statement ...
      fClose( fOpen( cFileName, "RW" ) )

   catch( exception e )

      if e.code == 108 // file in use by another
         lReturn = true
      else // file or directory does not exist, etc.
         lReturn = false
         msgbox( e.code+chr(13)+e.message, "Error", 16 )
      endif
   endtry

return lReturn

/*
   End of program/function: IsExeOpen()
*/

