/*
   File:   kmDateWithCal.h
   Author: Ken Mayer
   Date:   January 26, 2017

   The header file for kmDateWithCal.cc, ultimately to be used with the
   dUFLP. 
   
   If you wish to modify the images, text, speedTip text, etc.,
   this is the place to do it, but you should make a "local" copy
   of the .H file and change the local copy.
*/

// *************************************************
// For the entryfield:
// *************************************************
#define EFNormalColor    "WindowText/Window"
#define EFColorHighlight "WindowText/0x80ffff"

// *************************************************
// For the pushbutton next to the entryfield:
// *************************************************

#define CalButton1 "RESOURCE PNG/calendar :resources:dFugue_24.dll"
#define CalButton2 "RESOURCE PNG/calendarexport :resources:dFugue_24.dll"
#define CalBtnSpeedTip1 "Click to display calendar"
#define CalBtnSpeedTip2 "Click to close the calendar"

// *************************************************
// Everything else below is for the calendar itself:
// *************************************************

/* Text in titlebar */
#define CalendarTitleText "Calendar"

/*
   Color definitions are used to define the buttons:
     NormalColor is the normal color used if not selected
     SelectedColor is what it sounds like, so that the
        currently selected date stands out
     SundayColor is used to show the first column
        (Sunday) ... a lot of calendars do this, so 
        I figured I would, too ...
     HolidayColor is used to show holidays ...
     MouseOverColor is used when the mouse "hovers" over
       the date buttons

        Note that holidays that are in the array defined
        by "LoadHolidays" (a method of the calendar class)
        will appear in this color as well, unless they 
        are the "selected" item ...
*/
#define NormalColor    "black/white"
#define SelectedColor  "white/blue"
#define SundayColor    "maroon/white"
#define HolidayColor   "green/white" // lighten this color up
#define MouseOverColor "red/white"

/*
   Define height/width/positioning of
   pushbuttons based on fontSize. 
   
   PaddingSize constant is used to deal with
   adding padding to the left/right/top/bottom
   (simply adding the PaddingSize * 2 when
   defining height will give us, hopefully, enough
   room for descenders and such).
   
   You should not change anything with calculations
   unless you're very careful, maybe save as a new
   version, in case the calculation gets thrown off
   badly.
*/

// Basics:
#define ButtonFontName "Arial" // Change at your peril -- some fonts
                               // can get weird ...
#define ButtonFontSize 12 // points -- standard font sizes
#define PaddingSize     5 // pixels -- you may need to experiment
                          // with this. At 10, 12, 14 and 16 point fontSize, 
                          // 5 seems to be good for padding, using Arial
                          // as the font ...                             
                          
// these two are used for increment/decrement buttons to
// add/subtract months/years:   
#define MonthIncrement  3 // default is 3
#define YearIncrement  10 // default is 10

// Language stuff for "Today" button and for
// speed tips for some buttons:
#define TodayText       "Today"
#define TimeSpeedTip1   "Time"
#define TimeSpeedTip2   "Back to Calendar"
#define TodaySpeedTip   "Go to Today's Date"
#define CancelSpeedTip  "Cancel Changes"
#define MonthText       "Month" 
#define MonthsText      "Months"
#define YearText        "Year"
#define YearsText       "Years"
#define BackText        "Back"
#define PreviousText    "Previous"
#define AheadText       "Ahead"
#define NextText        "Next"
#define HoursText       "H:"
#define HoursSpeedTip   "Hours"
#define MinutesText     "M:"
#define MinutesSpeedTip "Minutes"
#define SecondsText     "S:"
#define SecondsSpeedTip "Seconds"
#define TimeTitleText   "Modify Time"

// Images -- change these to what is normally used for the upBitMap
// property of an image:
#define NextButtonImg  "RESOURCE PNG/control :resources:dFugue_16_1.dll"
#define Next10BtnImg   "RESOURCE PNG/controldouble :resources:dFugue_16_1.dll"
#define PrevButtonImg  "RESOURCE PNG/control180 :resources:dFugue_16_1.dll"
#define Prev10BtnImg   "RESOURCE PNG/controldouble180 :resources:dFugue_16_1.dll"
#define TodayBtnImg    "RESOURCE PNG/calendarselect :resources:dFugue_16_1.dll"
#define UndoButtonImg  "RESOURCE PNG/arrowcircle225left :resources:dFugue_16_1.dll"
#define TimeButtonImg  "RESOURCE PNG/alarmclockblue :resources:dFugue_16_1.dll"
#define TimeBackImg    "RESOURCE PNG/calendarimport :resources:dFugue_16_1.dll"
