/*
    mbimage.cc

    Author:  Mervyn Bick
    Date..:  May, 2010
    Notes.:  This custom control creates an image that can be dragged around the form
             by placing the cursor over the image and holding down the left mouse button.
             
             The image stays visible while it is being dragged. 

             The image remembers where it was placed whan the form was last closed. 

             To use this custom control, place it on a form, resize as needed and allocate 
             an immage to the datasource property.

             Tested with dBase Plus v2.6.0.1 under Windows XP Professional, SP3

    WARNING: The control creates a .dbf file with the same name as the form's className. If 
             the same className is used in a different .wfm file in the same folder and this
             control is also used in the second form the .dbf file will be corrupted.   

*/

class MBIMAGE(parentObj, name) of IMAGE(parentObj, name) custom
   with (this)
      onLeftMouseDown = class::onLeftMouseDown
      onOpen = class::onOpen
      onClose = class::onClose
   endwith

   function onOpen
      if type("SendMessageA") # "FP"
         extern clong  SendMessageA(chandle, CUINT, cuint, cuint) user32
      endif

      cImagename= "MB"+this.name
      cParentname = this.parent.classname
      cFilename = cParentname+".dbf"
      nImageLeft = this.left
      nImageTop  = this.top

      if not file(cFilename)
         cmd = [create table ]+cParentname+[ (imagename character(15),imageleft numeric(10,2),]
         cmd +=[imagetop numeric(10,2))]
         &cmd
      endif

      this.q = new query()
      this.q.sql = "select * from "+cParentname
      this.q.active = true
      if this.q.rowset.applyLocate("imagename = '" + cimagename + "'")
         this.left = this.q.rowset.fields[2].value
         this.top =  this.q.rowset.fields[3].value
      else
          cmd = [insert into ]+cParentname+[ (imagename,imageleft,imagetop) ]
          cmd +=[values ("]+cImagename+[",]+nImageLeft+[,]+nImageTop+[)]
          &cmd
      endif
      return

 
   function onLeftMouseDown
      SendMessageA(this.hwnd, 0x00A1,2, 0) // WM_NCLBUTTONDOWN = 0x00A1
      class::savePosition()
      return

   function savePosition
      this.q.rowset.applyLocate([imagename = '] + "MB"+this.name + [']) 
      this.q.rowset.beginedit()
      this.q.rowset.fields[2].value = this.left
      this.q.rowset.fields[3].value = this.top
		this.q.rowset.save()
      return

   function onClose
      this.q.active = false
      this.q = null
      return


 endclass

